/*
 * Version: MPL v. 1.1
 *
 * The contents of this file are subject to the MPL License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/MPL-1.1.txt
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FoxLingo.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */

Foxlingo.Customize = function() {
    var pub = {};


    //public functions
    pub.onCustomizeChangeStyle = function() {
        var changeStyleOption = document.getElementById('modelist');
        var showOpt = changeStyleOption.value;
        
        Foxlingo.Prefs.setCharPref("customizeshowbuttontext", showOpt);
        
        var isShowText = (showOpt!="icons"); 
        Foxlingo.Prefs.setBoolPref("showbuttontext", isShowText);
        Foxlingo.Toolbar.toggleToolbarButtonsText(isShowText);
    };
    
    pub.onToolboxCustomizeStarted = function() { 
        var changeStyleOption = document.getElementById('modelist');
        var showOpt = changeStyleOption.value;
        var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
        var enumerator = windowMediator.getEnumerator("");
        while(enumerator.hasMoreElements()) {
            var win = enumerator.getNext();
            var flSearchBox = win.document.getElementById("Foxlingo_searchterms-item");
            if (flSearchBox) 
                Foxlingo.Search.tempSearchTerms = flSearchBox.value;
            else
                Foxlingo.Search.tempSearchTerms = null;
            pub.applyStyles();
        }
    };
    
    pub.onToolboxCustomizeFinished = function() {
        var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
        var enumerator = windowMediator.getEnumerator("");
        while(enumerator.hasMoreElements()) {
            var win = enumerator.getNext();
            var highlighterItem = win.document.getElementById("Foxlingo_highlighter-item");
            var flSearchBox = win.document.getElementById("Foxlingo_searchterms-item");
            if (highlighterItem && flSearchBox && flSearchBox.value!=='')
                Foxlingo.Search.termsHaveUpdated();
            if (Foxlingo.Search.tempSearchTerms && flSearchBox) {
                flSearchBox.value = Foxlingo.Search.tempSearchTerms;
                Foxlingo.Search.termsHaveUpdated();
            }
            win.setTimeout("if (Foxlingo) Foxlingo.Search.updateSearchTerms();", 3000);
            Foxlingo.Toolbar.updateToolbarButtons();
            Foxlingo.Toolbar.updateToolbarButtonsText();
            pub.applyStyles();
        }
    };
    
    pub.applyStyles = function() {
        var platform = getPlatform();
        var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
        var enumerator = windowMediator.getEnumerator("");
        while(enumerator.hasMoreElements()) {
            var win = enumerator.getNext();
            var flSearchBox = win.document.getElementById("Foxlingo_searchterms-item");
            if (!flSearchBox)
                continue;
            var searchBox = win.document.getElementById("foxlingo-search-box");
            searchBox.maxLength = 256;
            switch (platform) {
                case 2:
                    searchBox.style.margin = "0px";
                    //fallthrough
                case 1:
                    searchBox.style.border = "none";
                    searchBox.style.MozAppearance = "none";
                    break;
                case 3:
                    var innerBox = document.getAnonymousElementByAttribute(searchBox, "class", "autocomplete-textbox-container");
                    if (!innerBox)
                        var innerBox = window.opener.document.getAnonymousElementByAttribute(searchBox, "class", "autocomplete-textbox-container");
                    innerBox.style.MozAppearance = "none";
                    innerBox.style.border = "none";
                    flSearchBox.style.MozAppearance = "menulist-textfield";
                    break;
            }
        }
    };
    
    function getPlatform() {
        var platform = Components.classes["@mozilla.org/network/protocol;1?name=http"].getService(Components.interfaces.nsIHttpProtocolHandler).oscpu;
        if (platform.indexOf("Win")!=-1) 
            return 1;
        else if (platform.indexOf("Mac")!=-1) 
            return 2;
        else if (platform.indexOf("Linux")!=-1 || platform.indexOf("FreeBSD")!=-1) 
            return 3;
        
        return 1;
    }
    

    return pub;
}();
