/*
 * Version: MPL v. 1.1
 *
 * The contents of this file are subject to the MPL License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/MPL-1.1.txt
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FoxLingo.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */

Foxlingo.Locale = function() {
    var pub = {};

    //public properties
    pub.geobytesXMLHttp = new XMLHttpRequest();


    //public functions
    pub.getSetLocale = function() {
        var clientfflocale;
        
        if (Foxlingo.Utils.isFF) {
            var oPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
            var oDefPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getDefaultBranch("general.useragent.");
            var localeToSet = oPrefService.getCharPref("general.useragent.locale").split('-')[0];
            var countryToSet = oPrefService.getCharPref("general.useragent.locale").split('-')[1];
            localeToSet = pub.changeFFLocaleCode(localeToSet);
            clientfflocale = localeToSet + '-' + countryToSet;
        } else {
            var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
            clientfflocale = chromeRegistry.getSelectedLocale("global");
        }
        Foxlingo.Prefs.setCharPref("clientfflocale", clientfflocale);
    };
    
    pub.getLocaleFromI2L = function(ipAddress) {
        //var urlToSend = "http://track.zugo.com/getCountry/";
	//var urlToSend = "http://nl.ae/iptocapi.php?type=1&ip=" + ipAddress;
	var urlToSend = "http://api.hostip.info/country.php"
        pub.geobytesXMLHttp.onreadystatechange = gotLocaleFromI2L;
        pub.geobytesXMLHttp.open("GET", urlToSend, true);
        pub.geobytesXMLHttp.send(null);
    };
    
    pub.changeFFLocaleCode = function(localeCode) {
        var retVal;
        switch (localeCode) {
            case "bg" : retVal = "bu"; break;
            case "cy" : retVal = "we"; break;
            case "fa" : retVal = "pe"; break;
            case "fil" : retVal = "ph"; break;
            case "id" : retVal = "in"; break;
            case "is" : retVal = "ic"; break;
            case "ms" : retVal = "ma"; break;
            case "nb" : retVal = "no"; break;
            case "nn" : retVal = "no"; break;
            case "pl" : retVal = "po"; break;        
            case "sr" : retVal = "se"; break;
            case "tr" : retVal = "tu"; break;
            case "zh" : retVal = "cn"; break;
            default: retVal = localeCode; break;
        }
        return retVal;        
    };
    

    //private functions
    function getLocaleFromGeobytes(ipAddress) {
        var urlToSend = "http://nl.ae/iptocapi.php?type=1&ip=" + ipAddress;
//        var urlToSend = "http://api.wipmania.com/" + ipAddress;
        pub.geobytesXMLHttp.onreadystatechange = gotLocaleFromGeobytes;
        pub.geobytesXMLHttp.open("GET", urlToSend, true);
        pub.geobytesXMLHttp.send(null);
    }
    
    function gotLocaleFromI2L() {
        gotLocaleFromGeobytes(true);
    }
    
    function gotLocaleFromGeobytes(fromI2L) {
        if (pub.geobytesXMLHttp.readyState==4 || pub.geobytesXMLHttp.readyState=="complete") { 
            var xmlHttpResponseText = pub.geobytesXMLHttp.responseText;
            if (xmlHttpResponseText) {
                if (fromI2L && xmlHttpResponseText.replace(/ /, "")==='') {
                        getLocaleFromGeobytes(Foxlingo.Prefs.getCharPref("clientipaddress")); 
                }
                if (xmlHttpResponseText.replace(/ /, "")!=='') {
                    if (xmlHttpResponseText.toLowerCase()=="us" &&
			Foxlingo.Prefs.getCharPref("defaultsearchengine") == "zugoBing" &&
			Foxlingo.Prefs.getBoolPref("isToolbarRegistered")) {
			//Do nothing for existing zugoBing users
                    } else {
			Foxlingo.Prefs.setCharPref("defaultsearchengine","ixquick");
                    }
		    Foxlingo.Toolbar.setToolbar(false); 
		    if (Foxlingo.Prefs.getBoolPref("isShowInstaller")) {
			Foxlingo.Prefs.setBoolPref("isShowInstaller", false);
			window.setTimeout(function() { window.openDialog('chrome://foxlingo/content/install.xul', '', 'chrome,centerscreen,scrollbars=no'); Foxlingo.initializeOnFirefoxLoad(false); }, 500);
			Foxlingo.Options.initializeInstallOptions();
		    }
		    if (Foxlingo.Prefs.getBoolPref("isShowAfterDownloadPage")) {
			Foxlingo.Utils.openAfterDownloadPage();
			Foxlingo.Prefs.setBoolPref("isShowAfterDownloadPage", false);
		    }
                    var oPrefService = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranchInternal);
                    var oDefPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getDefaultBranch("general.useragent.");
                    var ffDefaultLocale = oDefPref.getCharPref("locale").split('-')[0];
                    var ffDefaultCountry = oDefPref.getCharPref("locale").split('-')[1];
                    var ffLocale = oPrefService.getCharPref("general.useragent.locale").split('-')[0];
                    var ffCountry = oPrefService.getCharPref("general.useragent.locale").split('-')[1];
                    
                    var localeToSet = ffLocale;
                    var countryToSet = ffCountry;
                    if (!Foxlingo.Utils.isFF) {
                        var chromeRegistry = Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIXULChromeRegistry);
                        var defaultLocale = chromeRegistry.getSelectedLocale("global");        
                        ffLocale = defaultLocale.split('-')[0];
                        ffCountry = defaultLocale.split('-')[1];
                        ffLocale = pub.changeFFLocaleCode(ffLocale);
                        ffDefaultLocale = pub.changeFFLocaleCode(ffDefaultLocale);
                        localeToSet = ffLocale;    
                        countryToSet = ffCountry;
                        var changeLang = Foxlingo.Utils.changeLanguage(localeToSet, "long");        
                    }
                    
                    var clientLocale = localeToSet + '-' + countryToSet;
                    
                    Foxlingo.Prefs.setCharPref("foundipcountry", xmlHttpResponseText);
	            Foxlingo.Options.setSearchCheckboxesLabels();
	            Foxlingo.Options.setSearchCheckboxesLabels(true);
                    
                    var localeCode = Foxlingo.Utils.getDomain("language", xmlHttpResponseText.toLowerCase());
                    Foxlingo.Options.setLangToByLocale(localeCode, "locale");
                    Foxlingo.Options.setLangToByLocale(xmlHttpResponseText, "country");
                    if (xmlHttpResponseText=="US") {
                        Foxlingo.Options.setLangToOption("spanish", true);
                        Foxlingo.Options.setLangToOption("spanishla", true);
                    }
                    if (localeToSet=="en") {
                        if (Foxlingo.isAvailableLanguageFrom(localeCode)) {
                            Foxlingo.Prefs.setCharPref("translatedsearchlangfrom", localeCode);
                            Foxlingo.Prefs.setBoolPref("firsttimetranslatedsearch", false);
                        }
                        
                            Foxlingo.Prefs.setCharPref("options-dlang", localeCode);
                            Foxlingo.Prefs.setCharPref("tempdlang", localeCode);
                         
                    }
                    Foxlingo.Options.setLangToOption(localeCode, true);
                    
                }            
            } else if (fromI2L) { 
                getLocaleFromGeobytes(Foxlingo.Prefs.getCharPref("clientipaddress")); 
            }
            
            var onlyEnglish = true;
            for (var language in Foxlingo.Languages) {
                if (Foxlingo.isAvailableLanguageTo(language)) {
                    if (language=="english")
                        continue;
                    if (Foxlingo.Prefs.getBoolPref(language + '-langto'))
                        onlyEnglish = false;
                }
            }
            if (onlyEnglish)
                Foxlingo.Options.setLangToOption("french", true);
        }
    }
    

    return pub;
}();
