/*
 * Version: MPL v. 1.1
 *
 * The contents of this file are subject to the MPL License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/MPL-1.1.txt
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FoxLingo.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */

Foxlingo.Menus = function() {
    var pub = {};

    //private properties
    //constants
    const ServiceCategories = ['dictionariesandencyclopedias', 'languageservices', 'texttospeech', 'languageidentification', 'learninglanguages', 'spellcheck',
                               'urltranslators', 'generallanguageinformation', 'freehumantranslation', 'professionaltranslation', 'otherservices'];

    //private members
    var mServices = {
        dictionariesandencyclopedias: ['wikipedia', 'acronymfinder', 'allwords', 'anagramsite', 'answers', 'britannica', 'dicts', 'etymonline', 'hyperdictionary',
                                       'lexfn', 'medicinenet', 'medlineplus', 'mw', 'nearrhyme', 'pantheon', 'onelook', 'onelookreversedictionary', 'pcwebopedia',
                                       'rhymezone', 'sprawk', 'thefreedictionary', 'urbandictionary', 'verbix', 'webstersonlinedictionary', 'webster1828',
                                       'yourdictionary'],
        languageservices: ['promtspellchecking', 'babylon', 'bbcnews', 'gate2home', 'translationparalink', 'nationalholidays', 'textalyserurl',
                           'unhchr', 'separator', 'promptgomail', 'worldlingoemailtranslator', 'alphabettmema', 'israelfree'],
        texttospeech: ['actor', 'acapela', 'att', 'cepstral', 'eurocosmtexttospeech', 'linguatec', 'mary', 'pollyglotto', 'oddcast',
                       'syvum', 'sinovoice', 'verbio'],
        spellcheck: ['scmultilingual', 'scenglish', 'scotherlanguages'],
        scmultilingual: ['promtspellchecking', 'petamem', 'orangoo', 'madcoffee', 'javascriptspellcheck', 'bonjourspellcheck', 'lenguaje', 'thesolutioncafe'],
        promtspellchecking: ['promtspellcheckingenglish', 'promtspellcheckingfrench', 'promtspellcheckinggerman', 'promtspellcheckingitalian',
                             'promtspellcheckingportuguese', 'promtspellcheckingrussian', 'promtspellcheckingspanish'],
        scenglish: ['siteowner', 'design215', 'jacuba', 'telerik', 'chxo', 'spellchecknet', 'spellex', 'spellexmedical', 'xde'],
        scotherlanguages: ['kyprosorthographic', 'kwuntung', 'slicorrector', 'flip', 'bbcwelshspeller', 'cswelshspellchecker'],
        languageidentification: ['googleli', 'eidetica', 'lexicoolg', 'petamemlangident', 'talenknobbel', 'textcat', 'xerox'],
        learninglanguages: ['multilingual', 'english', 'otherlanguages1', 'otherlanguages2', 'chinese', 'dutch', 'french', 'german', 'hebrew', 'hindi', 'japanese',
                            'spanish', 'signlanguages'],
        multilingual: ['bbclanguages', 'eurocosm', 'fonetiks', 'fsilanguagecourses', 'languagebuddy', 'languagegames', 'lingozone', 'lingup', 'mylanguageexchange',
                       'polyglotlearnlanguage', 'seasite', 'pdictionary', 'phrasebase', 'travlang', 'unilang', 'wikipediacommonphrases', 'wikibookslanguagesbookshelf'],
        english: ['1language', 'dailygrammar', 'englishonline', 'lapasserelle', 'etymologic', 'freeenglish', 'funbrain', 'hgpublishing', 'superteach',
                  'wordsmith'],
        otherlanguages1: ['afrikaansus', 'babelarabic', 'buber', 'learnbulgarian', 'hrvatska', 'bohemica', 'speakdanish', 'tscasdanish', 'enhavo', 'esperantoca',
                          'finnishgrammar', 'venla', 'greece', 'kypros', 'hungarotips', 'icelandiconline', 'mimir'],
        otherlanguages2: ['expat', 'unification', 'rkikbs', 'humanum', 'hhhh', 'norskklassen', 'sofn', 'easypersian', 'golem', 'grzegorj', 'polishslavic',
                          'romanianlessons', 'masterrussian', 'bjornengdahl', 'personalpsu', 'caliarizona', 'turkishclass', 'morsecodetranslator'],
        chinese: ['chinesetools', 'wkuedu', 'melnyks', 'zapchinese'],
        dutch: ['forbeginners', 'hengeveld', 'learndutchnu', 'thinkdifferent'],
        french: ['bonjour', 'frenchassistant', 'learnfrenchinboston', 'frenchtutorial'],
        german: ['deutschlernen', 'exeter', 'germanfortravellers'],
        hebrew: ['akhlah', 'foundationstone', 'hebrewverbs', 'ivritbkalut', 'zigzag'],
        hindi: ['ncsu', 'philae', 'nyu'],
        japanese: ['japancast', 'japaneseonline', 'writejapan'],
        spanish: ['businessspanish', 'elemadrid', 'studyspanish', 'spanishkit'],
        signlanguages: ['asldictionary', 'britishsign', 'lessontutor', 'lifeprint', 'signwriting', 'worldsig'],
        urltranslators: ['dialectizer', 'psyclops', 'crapola', 'babelsheep', 'ultralingua', 'voycabulary', 'rikai'],
        dialectizer: ['dredneck', 'djive', 'dcockney', 'delmerfudd', 'dswedishchef', 'dmoron', 'dpiglatin', 'dhacker'],
        psyclops: ['ppimp', 'pskinhead', 'phacker', 'psmurf', 'pozzie', 'pcockney', 'predneck'],
        crapola: ['yoda', 'rot13', 'ayb', 'boston', 'canadian', 'haxor', 'ebonics', 'valley', 'binary', 'jeffk', 'ultraleet', 'martian', 'piglatin', 'smurf'],
        generallanguageinformation: ['learnalanguage', 'phoneticalphabets', 'voiceproblemlearning', 'wikipediahowtolearnalanguage', 'wikipedialanguage',
                                     'wikipedialanguagebookshelf'],
        freehumantranslation: ['ardom', 'click2translate', 'cucumis', 'freelocalization', 'freetranslator', 'freelang', 'sylang', 'translateandsavespanish', 'unilang',
                               'writing'],
        professionaltranslation: ['worldlingopt', 'globalpt', 'tranexppt'],
        otherservices: ['brainboost', 'clusty', 'creativecommons', 'delicious', 'ebay', 'findsounds', 'flickr', 'gchart', 'googlemaps', 'imdb', 'ixquickphonesearch',
                        'librivox', 'onlineconversion', 'shopping', 'soundclick', 'speegle', 'stumbleupon', 'talkbackwards', 'yubnub', 'googlefinance', 'yahoofinance',
                        'accuweather', 'videos'],
        videos: ['dailymotion', 'googlevideo', 'ifilm', 'maniatv', 'metacafe', 'veoh', 'youtube']
    };
    

    //public functions
    pub.createMenuItems = function(type, langfrom) {
        var tempItem;
        var menu = document.getElementById(type + "-" + langfrom);
        var isOneTranslatorPerPair = Foxlingo.Prefs.getBoolPref("onetranslatorperpair");

        if (!menu) 
            return;
        
        if (menu.childNodes.length!==0)
            return;
        
        Foxlingo.Utils.removeChildren(menu);
        for (var langto in Foxlingo.Languages) {
            if (!Foxlingo.isAvailableLanguageTo(langto) || langfrom==langto || !Foxlingo.Prefs.getBoolPref(langto + "-langto"))
                continue;

            for each (var translator in Foxlingo.Translation.Translators) {
                if (!isCreateMenuItem(translator, langfrom, langto, type))
                    continue;

                tempItem = document.createElement("menuitem");
                setFlagAndLabel("menui", tempItem, langfrom, langto, translator);
                tempItem.setAttribute("class", "menuitem-iconic");
                tempItem.setAttribute("onclick", "event.stopPropagation();");
                var functionname;
                if (type=="Foxlingo_toolbar-umenu" || type=="Foxlingo" || type=="Foxlingo_context-umenu" ||
                    type=="Foxlingo_status-umenu") {
                    functionname = 'event.stopPropagation(); Foxlingo.Translation.translateUrl';
                } else {
                    functionname = "Foxlingo.Translation.Text.translateText";
                }
                
                var commandStr = functionname + "('" + langfrom + "', '" + langto + "', '" + translator + "', false, " + (type=='Foxlingo_context-umenu') + ")";
                tempItem.setAttribute("oncommand", commandStr);
                
                menu.appendChild(tempItem);
                if (isOneTranslatorPerPair)
                    break;
            }
        }
        if (Foxlingo.Languages[langfrom].numLangPairs > menu.childNodes.length ||
            (type=="Foxlingo" && menu.childNodes.length===0)) {
            tempItem = document.createElement("menuitem");
            tempItem.setAttribute("label", document.getElementById("foxlingo-stringbundle").getString("foxlingo.text.not.available"));
            tempItem.setAttribute("tooltiptext", document.getElementById("foxlingo-stringbundle").getString("foxlingo.text.not.available"));
            tempItem.setAttribute("oncommand", "window.openDialog('chrome://foxlingo/content/options.xul', 'foxlingoOptionsDialog', 'centerscreen,chrome,resizable,toolbar,titlebar', '3');");
            tempItem.setAttribute("onclick", "");
            menu.appendChild(tempItem);
        }
    };
           
    pub.updateOverflowMenu = function() {
        var buttons = document.getElementById("Foxlingo_searchwordbuttons-item");
        var overflowMenu = document.getElementById("Foxlingo_Overflow-Menu");
        if (!buttons || !overflowMenu)
            return;
            
        for (var i = 1; i<buttons.childNodes.length; i++) {
            var button = buttons.childNodes[i];
            if (button.id=="Foxlingo_wordfindCustomize")
                continue;
            var menu = overflowMenu.childNodes[i - 1];
            if (menu && menu.collapsed==button.collapsed) 
                menu.collapsed = !menu.collapsed;
        }
    };
    
    pub.createDlangMenuItem = function(columns, qi) {
        if (!qi)
            qi = '';
        var strbundle = document.getElementById("foxlingo-stringbundle");
        var menuLabel = document.getElementById("options-dlang-parent" + qi);
        var chosenDlang = 0;
        var index = 0;
        for (var language in Foxlingo.Languages) {
            if (language=="auto")
                continue;
            var tempMenuItem = document.createElement("menuitem");
            tempMenuItem.setAttribute("id", "dlang" + qi + "-" + language);
            tempMenuItem.setAttribute("label", strbundle.getString("foxlingo.language." + language));
            if (!qi)
                tempMenuItem.setAttribute("value", language);
            tempMenuItem.setAttribute("oncommand", "Foxlingo.Prefs.setCharPref('tempdlang','" + language + "')");
            columns.appendChild(tempMenuItem);
            if (language==Foxlingo.Prefs.getCharPref("options-dlang")) {
                menuLabel.setAttribute("label", strbundle.getString("foxlingo.language." + language));
                chosenDlang = index;
            }
            index++;
        }
        menuLabel.selectedIndex = chosenDlang;
    };
    
    pub.createCurrencyMenuItem = function(columns) {
       //var strbundle = document.getElementById("foxlingo-stringbundle");
        var menuLabel = document.getElementById("options-currency-parent");
        var chosenCurrency = 0;
        var index = 0;
        for (var currency in Foxlingo.Currencies) {
            if (currency=="auto")
                continue;
            var tempMenuItem = document.createElement("menuitem");
            tempMenuItem.setAttribute("id", "currency" + currency);
            // tempMenuItem.setAttribute("label", strbundle.getString("foxlingo.currency." + currency));
            tempMenuItem.setAttribute("label", currency);
            tempMenuItem.setAttribute("value", currency);
            tempMenuItem.setAttribute("oncommand", "Foxlingo.Prefs.setCharPref('tempcurrency','" + currency + "')");
            columns.appendChild(tempMenuItem);
            if (currency==Foxlingo.Prefs.getCharPref("options-currency")) {
                // menuLabel.setAttribute("label", strbundle.getString("foxlingo.language." + currency));
                menuLabel.setAttribute("label", currency);
                chosenCurrency = index;
            }
            index++;
        }
        menuLabel.selectedIndex = chosenCurrency;
    };
    pub.createAllMenus = function(updateEmptyMenus) {  
        var webpageMenu = '';
        var textMenu = '';

        if (Foxlingo.Prefs.getBoolPref("button-webtranslation")) {
            createMenus('Foxlingo_toolbar-umenu', updateEmptyMenus);
            webpageMenu = 'Foxlingo_toolbar-umenu';
        }
        if (Foxlingo.Prefs.getBoolPref("button-texttranslation")) {
            createMenus('Foxlingo_menu_Text', updateEmptyMenus);
            textMenu = 'Foxlingo_menu_Text';
        }
            
        if (Foxlingo.Prefs.getBoolPref("button-services")) 
            createSmenus('Foxlingo_toolbar-smenu');

        createMenus('Foxlingo_context-umenu', updateEmptyMenus);
        createMenus('Foxlingo_context-tmenu', updateEmptyMenus);
        createContextMenu(webpageMenu, "Foxlingo_context-webtranslation-item");
        createContextMenu(textMenu, "Foxlingo_context-texttranslation-item");
        createContextMenu("Foxlingo_context-dmenu", "Foxlingo_context-dictionary-item");
        createStatusMenu(webpageMenu);
            
        createSearchSmenu('dictionariesandencyclopedias', true);
        createSearchSmenu('languageservices', true);
        createSearchSmenu('otherservices', true);
        createTranslatedSearchMenus();
    };

    pub.buildFlagsOverflowMenu = function() {
        var overflowmenu = document.getElementById("Foxlingo_flagsOverflowMenu");

        if (!overflowmenu)
            return;

        Foxlingo.Utils.removeChildren(overflowmenu);
        
        var strbundle = document.getElementById("foxlingo-stringbundle");
        
        for (var language in Foxlingo.Languages) {
            if (!Foxlingo.isAvailableLanguageFrom(language))
                continue;
                
            var tempButton = document.createElement("menu");
            var tempPopup = document.createElement("menupopup");
            var tempLang = language; 
                       
            tempButton.setAttribute("id", "Foxlingo_" + tempLang + "-itemoverflow");
            tempButton.setAttribute("type", "menu");
            tempButton.setAttribute("label", strbundle.getString("foxlingo.language." + tempLang));
            tempButton.setAttribute("class",  "menu-iconic");
            
            var flagLang = Foxlingo.Toolbar.Flags.getFlagLang(language);

            tempButton.setAttribute("image", "chrome://foxlingo/skin/flags-s/" + flagLang + ".png");
            tempButton.setAttribute("tooltiptext", strbundle.getString("foxlingo.language." + tempLang));
            tempPopup.setAttribute("id", "toolbaroverflow-" + tempLang);
            tempPopup.setAttribute("onpopupshowing", "Foxlingo.Menus.createMenuItems('toolbaroverflow', '" + tempLang + "');");
            tempPopup.setAttribute("class", "menu-iconic");
            
            tempButton.setAttribute("collapsed", "true");
            tempButton.appendChild(tempPopup);
            overflowmenu.appendChild(tempButton);
        }
    };


    //private functions
    function isCreateMenuItem(translator, langfrom, langto, type) {
        if (!Foxlingo.Prefs.getBoolPref(translator))
            return false;
        if (!Foxlingo.Translation.Text.doesTranslatorSupportTextTranslation(translator) && isTextTranslationMenu(type))
            return false;
        
        return doesTranslatorSupportPair(langfrom, langto, translator);
    }

    function isTextTranslationMenu(type) {
        return (type=="Foxlingo_menu_Text" || type=="Foxlingo_context-tmenu")
    }

    function createMenus(type, updateEmptyMenus) {
        var menu = document.getElementById(type);
        
        if (!menu)
            return;

        Foxlingo.Utils.removeChildren(menu);

        if (type!="Foxlingo_context-umenu" && type!="Foxlingo_context-tmenu") {
            var bundle = document.getElementById("foxlingo-stringbundle");
            var label = bundle.getString("foxlingo.text.webpageTranslation");
            if (isTextTranslationMenu(type))
                label = bundle.getString("foxlingo.text.textTranslation");
            var tempItem = document.createElement("menuitem");
            tempItem.setAttribute("label", label);
            tempItem.setAttribute("style", "font-weight: bold;");
            menu.appendChild(tempItem);
        }

        for (var language in Foxlingo.Languages) { 
            if (Foxlingo.isAvailableLanguageFrom(language) && Foxlingo.Prefs.getBoolPref(language + "-langfrom")) 
                createMenu(type,language, menu, updateEmptyMenus); 
        }
        if (menu.childNodes.length > 0)
            return;
            
        var tempItem = document.createElement("menuitem");
        tempItem.setAttribute("label", document.getElementById("foxlingo-stringbundle").getString("foxlingo.text.not.available"));
        tempItem.setAttribute("tooltiptext", document.getElementById("foxlingo-stringbundle").getString("foxlingo.text.not.available"));
        tempItem.setAttribute("oncommand", "window.openDialog('chrome://foxlingo/content/options.xul', 'foxlingoOptionsDialog', 'centerscreen,chrome,resizable,toolbar,titlebar', '3');");
        tempItem.setAttribute("onclick", "");
        menu.appendChild(tempItem);
    }
    
    function createMenu(type, langfrom, menu, updateEmptyMenus) {
        var isCreate = false;
        var menuList = Foxlingo.session.emptyMenuList;
        if (!menuList)
            menuList = '';
        if (updateEmptyMenus) {
            if (isCreateMenu(type, langfrom, menu, updateEmptyMenus)) {
                isCreate = true;
                Foxlingo.session.emptyMenuList = menuList + type + '-' + langfrom;
            } else {
                Foxlingo.session.emptyMenuList = menuList.replace(type + '-' + langfrom, '');
            }
        } else if (menuList.indexOf(type + '-' + langfrom)!=-1) {
            isCreate = true;
        }
        
        if (!isCreate)
            return;

        var tempMenuItem = document.createElement("menu");
        var tempMenuPopup = document.createElement("menupopup");
        setFlagAndLabel("menu", tempMenuItem, langfrom);
        tempMenuItem.setAttribute("class", "menu-iconic");
        tempMenuPopup.setAttribute("id", type + "-" + langfrom);
        tempMenuPopup.setAttribute("onpopupshowing", "Foxlingo.Menus.createMenuItems('" + type + "', '" + langfrom + "')");
        var isTextTranslation = false;
        if (isTextTranslationMenu(type))
            isTextTranslation = true;
        if ((type=="Foxlingo_toolbar-umenu") || (type=="Foxlingo") || 
            (type=="Foxlingo_context-umenu") || (type=="Foxlingo_status-umenu") || isTextTranslationMenu(type)) 
            tempMenuItem.setAttribute("onclick", "if (event.target==this) Foxlingo.Translation.Auto.autotranslateFrom('" + langfrom + "', " + isTextTranslation + ")");
        
        tempMenuItem.appendChild(tempMenuPopup);
        menu.appendChild(tempMenuItem);
    }

    function isCreateMenu(type, langfrom, menu, updateEmptyMenus) {
        var i, j;                   
        for (var language in Foxlingo.Languages) {
            if (!Foxlingo.isAvailableLanguageTo(language) || langfrom==language || !Foxlingo.Prefs.getBoolPref(language + "-langto"))
                continue;
                
            for each (var translator in Foxlingo.Translation.Translators) {
                if (Foxlingo.Prefs.getBoolPref(translator) && doesTranslatorSupportPair(langfrom, language, translator)
                    && (Foxlingo.Translation.Text.doesTranslatorSupportTextTranslation(translator) || !isTextTranslationMenu(type)))
                    return true;
            }
        }
        
        return false;
    }
    
    function createSmenus(type) {
        var smenu = document.getElementById(type);
        if (!smenu)
            return;
            
        Foxlingo.Utils.removeChildren(smenu);    
        createSmenu(type, smenu);    
    }
    
    function createSearchSmenu(type, withSelection) {
        var onClick;
        var tempItem;
        var smenu = document.getElementById("Foxlingo_search-" + type + "-popup");
        if (!smenu)
            return;
        
        Foxlingo.Utils.removeChildren(smenu);
        for each (var service in mServices[type]) {
            if (mServices[service]) { // in case this is a subcategory                        
                var tempSubSmenu = createSearchSubmenu(service, withSelection);
                if (tempSubSmenu)
                    smenu.appendChild(tempSubSmenu);                
            } else if (service!="separator" &&
                       ((withSelection && Foxlingo.Service.doesServiceUseSpecialSelection(service)) || !withSelection)) { //otherwise, it's a simple menuitem
                onClick = 'Foxlingo.openSite("' + service + '", "textbox")';
                if (Foxlingo.Prefs.getBoolPref("translatedsearch"))
                    onClick = 'Foxlingo.Translation.openSiteTranslated("' + service + '")';
                tempItem = createServiceMenuItem(service, onClick, true);
                smenu.appendChild(tempItem);
            }
        }
        
        if (type=='languageservices') {
            mServices[type].pop();
            mServices[type].pop();
        }
    }

    function createSearchSubmenu(name, withSelection) {
        var strbundle = document.getElementById("foxlingo-stringbundle");
        var tempSubSmenu = document.createElement('menu');
        var tempSubSmenuPopup = document.createElement('menupopup');
        var sSubMenuLabel = strbundle.getString('foxlingo.menu.' + name);                

        tempSubSmenu.setAttribute('class', 'menu-iconic');
        tempSubSmenu.setAttribute('label', sSubMenuLabel);    
        tempSubSmenu.setAttribute('tooltiptext', sSubMenuLabel);    
        tempSubSmenu.setAttribute('image', 'chrome://foxlingo/skin/services/' + name + '.png');
        
        if (name=='promtspellchecking') {
            tempSubSmenu.setAttribute('id', 'promticonsearch');
            tempSubSmenu.setAttribute('onclick', 'Foxlingo.Search.Dictionary.openPromtSite();');
        }
        
        for each (var service in mServices[name]) {
            if (service=="separator" ||
                (withSelection && !Foxlingo.Service.doesServiceUseSpecialSelection(service)))
                continue;
                
            var onClick = 'Foxlingo.openSite("' + service + '", "textbox")';
            if (name=='promtspellchecking')
                onClick = 'Foxlingo.Search.Dictionary.updatePromtSite("' + service + '"); Foxlingo.openSite("' + service + '", "textbox")';
            else if (Foxlingo.Prefs.getBoolPref("translatedsearch"))
                onClick = 'Foxlingo.Translation.openSiteTranslated("' + service + '");';
            var tempItem = createServiceMenuItem(service, onClick, true);
            
            tempSubSmenuPopup.appendChild(tempItem);                                
        }
        
        tempSubSmenu.appendChild(tempSubSmenuPopup);
        if (tempSubSmenuPopup.childNodes.length > 0)
            return tempSubSmenu;                
    }
    
    function createServiceMenuItem(service, onClick, isSetOnMouseFunctions, onCommand) {
        var strbundle = document.getElementById("foxlingo-stringbundle");
        var tempItem = document.createElement('menuitem');
        var smenuItemLabel = strbundle.getString('foxlingo.menuitem.' + service);
        tempItem.setAttribute('class', 'menuitem-iconic');
        tempItem.setAttribute('label', smenuItemLabel);            
        tempItem.setAttribute('tooltiptext', smenuItemLabel);            
        tempItem.setAttribute("image", "chrome://foxlingo/skin/services/" + service + '.png');
        if (onClick)
            tempItem.setAttribute('onclick', onClick);
        if (onCommand)
            tempItem.setAttribute('oncommand', onCommand);
        else
            tempItem.setAttribute('oncommand', 'event.stopPropagation();');
        if (isSetOnMouseFunctions) {
            tempItem.setAttribute('onmouseover', 'Foxlingo.Status.showStatusMessage(Foxlingo.openSite("' + service + '", null, true));');
            tempItem.setAttribute('onmouseout', 'Foxlingo.Status.restoreStatusMessage();');
        }
        return tempItem;
    }

    function createSmenu(type, smenu, withSelection) {
        var tempItem, smenuItemLabel;
        for each (var serviceCategory in ServiceCategories) {
            var tempSmenu = createServiceCategoryMenu(serviceCategory, withSelection);
            smenu.appendChild(tempSmenu);
        }
    }
    
    function createServiceCategoryMenu(name, withSelection, depth) {
        if (!depth)
            depth = 0;
        if (depth>0 && name=='promptspellchecking')
            return null;

        var strbundle = document.getElementById("foxlingo-stringbundle");
        var tempSmenu = document.createElement('menu');
        var tempSmenuPopup = document.createElement('menupopup');
        var smenuLabel = strbundle.getString('foxlingo.menu.' + name);        
        
        tempSmenu.setAttribute('class', 'menu-iconic');
        tempSmenu.setAttribute('image', 'chrome://foxlingo/skin/services/' + name + '.png');
        tempSmenu.setAttribute('label', smenuLabel);
        tempSmenu.setAttribute('tooltiptext', smenuLabel);
        if (depth===0 && !mServices[name])
            return tempSmenu;
                    
        for each (var service in mServices[name]) {
            var tempItem;
            
            if (depth<2 && service=="separator") {
                if (depth==1 && !withSelection)
                    tempItem = document.createElement('menuseparator');
            } else if (mServices[service]) { // in case this is a subcategory
                if (depth>0 || name!='languageservices')
                    tempItem = createServiceCategoryMenu(service, withSelection, depth+1);
            } else if ((withSelection && Foxlingo.Service.doesServiceUseSpecialSelection(service)) || !withSelection) {
                var onClick;
                var onCommand;
                var func = 'Foxlingo.openSite("' + service + '", null)';
                if (depth===0)
                    onCommand = func;
                else
                    onClick = func;
                tempItem = createServiceMenuItem(service, onClick, true, onCommand);
            }
            if (tempItem)
                tempSmenuPopup.appendChild(tempItem);
        }
        
        if (tempSmenuPopup.childNodes.length > 0)
            tempSmenu.appendChild(tempSmenuPopup);
        return tempSmenu;
    }
    
    function createTranslatedSearchMenus() {
        var tsLangFromMenu = document.getElementById("Foxlingo_translatedsearch-langfrom");
        var tsLangToMenu = document.getElementById("Foxlingo_translatedsearch-langto");
        var langToMenu = document.getElementById("Foxlingo_translatedsearchmenu-langto");
        var langFromMenu = document.getElementById("Foxlingo_translatedsearchmenu-langfrom");
        var strbundle = document.getElementById("foxlingo-stringbundle");
            
        if (!tsLangFromMenu || !tsLangToMenu || !langToMenu || !langFromMenu)
            return;
            
        var langFrom;
        var langTo;
        if (Foxlingo.Prefs.getBoolPref("firsttimetranslatedsearch")) {    
            langFrom = Foxlingo.Prefs.getCharPref("options-dlang");
            langTo = "english";
            
            if (langFrom=='english')
                langTo = 'spanish';

            Foxlingo.Prefs.setBoolPref("firsttimetranslatedsearch", false);
            if (Foxlingo.isAvailableLanguageFrom(langFrom) && !Foxlingo.Prefs.getBoolPref("changedtsearchmanual")) {
                Foxlingo.Prefs.setCharPref("translatedsearchlangfrom", langFrom);
                Foxlingo.Prefs.setCharPref("translatedsearchlangto", langTo);
            }
        } else {    
            langFrom = Foxlingo.Prefs.getCharPref("translatedsearchlangfrom");
            langTo = Foxlingo.Prefs.getCharPref("translatedsearchlangto");
        }
        
        Foxlingo.Utils.removeChildren(tsLangFromMenu);
        Foxlingo.Utils.removeChildren(tsLangToMenu);
        
        for (var language in Foxlingo.Languages) {
            if (Foxlingo.isAvailableLanguageFrom(language)) {
                var tempFromItem = createLanguageMenuItem(language, "Foxlingo.Search.Translated.updateTranslatedSearchLangFrom('" + language + "', true);"); 
                if (language==langFrom)                
                    langFromMenu.setAttribute("image", "chrome://foxlingo/skin/flags-s/" + langFrom + ".png");
                tsLangFromMenu.appendChild(tempFromItem);
            }
            
            var tempToItem = createLanguageMenuItem(language, "Foxlingo.Search.Translated.updateTranslatedSearchLangTo('" + language + "', true);", "tsearch-langfrom-" + language);                
            if (language==langTo)            
                langToMenu.setAttribute("image", "chrome://foxlingo/skin/flags-s/" + langTo + ".png");
            tsLangToMenu.appendChild(tempToItem);
        }
    }
    
    function createLanguageMenuItem(language, onCommand, id) {
        var strbundle = document.getElementById("foxlingo-stringbundle");
        var tempItem = document.createElement("menuitem");
        if (id)
            tempItem.setAttribute("id", id);
        tempItem.setAttribute("name", "translatedsearchlangfrom");
        tempItem.setAttribute("image", "chrome://foxlingo/skin/flags-s/" + language + ".png");
        tempItem.setAttribute("label", strbundle.getString("foxlingo.language." + language));
        tempItem.setAttribute("class", "menuitem-iconic");        
        tempItem.setAttribute("oncommand", "event.stopPropagation(); " + onCommand);
        tempItem.setAttribute("tooltiptext", strbundle.getString("foxlingo.language." + language));
        return tempItem;
    }
    
    function createContextMenu(webpageMenu, parent) {
        var updateEmptyMenus = "";
        var isUseContextMenu = Foxlingo.Prefs.getBoolPref("usecontextmenu"); 
        
        var contextMenu = document.getElementById(parent);
        if (contextMenu)
            contextMenu.setAttribute("collapsed", !isUseContextMenu);

        if (!isUseContextMenu || webpageMenu=="Foxlingo_context-dictionary-item")
            return;
        var newMenu = document.getElementById('Foxlingo_context-umenu');
        if (isTextTranslationMenu(webpageMenu))
            newMenu = document.getElementById('Foxlingo_context-tmenu');
        
        if (!webpageMenu) {
            createMenus(newMenu, updateEmptyMenus);
            return;
        }
        
        var webpageMenuObject = document.getElementById(webpageMenu);
        var newMenuObject = document.getElementById(newMenu);
            
        if (!newMenuObject)
            return;
        if (!webpageMenuObject) {
            createMenus(newMenu, updateEmptyMenus);
            return;
        }
        Foxlingo.Utils.removeChildren(newMenuObject);
        for (var i = 0; i<webpageMenuObject.childNodes.length; i++) {
            var newMenuItem = webpageMenuObject.childNodes[i].cloneNode(true);
            if (!newMenuItem.childNodes[0])
                continue;
            newMenuItem.childNodes[0].setAttribute("id", newMenuItem.childNodes[0].getAttribute("id").replace(webpageMenu, newMenu));
            newMenuItem.childNodes[0].setAttribute("onpopupshowing", newMenuItem.childNodes[0].getAttribute("onpopupshowing").replace(webpageMenu, newMenu));
            newMenuObject.appendChild(newMenuItem);
        }
    }

    function createStatusMenu(webpageMenu) {
        var statusMenu = document.getElementById("foxlingo-status-panel");
        if (!statusMenu)
            return;
        
        var isUseStatusBar = Foxlingo.Prefs.getBoolPref("usestatusbar");
        statusMenu.setAttribute("collapsed", !isUseStatusBar);

        if (!isUseStatusBar)
            return;
            
        if (!webpageMenu) {
            createMenus('Foxlingo_status-umenu', updateEmptyMenus);
            return;
        }

        var webpageMenuObject = document.getElementById(webpageMenu);
        var newMenuObject = document.getElementById('Foxlingo_status-umenu');
        if (!newMenuObject)
            return;
            
        if (!webpageMenuObject) {
            createMenus('Foxlingo_status-umenu', updateEmptyMenus);
            return;
        }
        
        Foxlingo.Utils.removeChildren(newMenuObject);
        for (var i = 0; i<webpageMenuObject.childNodes.length; i++) {
            var newMenuItem = webpageMenuObject.childNodes[i].cloneNode(true);
            if (!newMenuItem.childNodes[0])
                continue;
            newMenuItem.childNodes[0].setAttribute("id", newMenuItem.childNodes[0].getAttribute("id").replace(webpageMenu, 'Foxlingo_status-umenu'));
            newMenuItem.childNodes[0].setAttribute("onpopupshowing", newMenuItem.childNodes[0].getAttribute("onpopupshowing").replace(webpageMenu, 'Foxlingo_status-umenu'));
            newMenuObject.appendChild(newMenuItem);
        }
    }

    function setFlagAndLabel(type, element, langfrom, langto, translator) {
        var strbundle = document.getElementById("foxlingo-stringbundle");
        var openp = strbundle.getString("foxlingo.openp");
        var space = strbundle.getString("foxlingo.space").replace(/&nbsp;/g," ").replace(/_/g," ");
        var txt = strbundle.getString("foxlingo.language." + langfrom);
        var flag;

        if (type=="menu") {
            flag = langfrom + Foxlingo.Utils.getSecondFlag(langfrom);
            txt += space + openp + "." + Foxlingo.Utils.changeLanguage(langfrom, "domain");
        } else {
            flag = langto + Foxlingo.Utils.getSecondFlag(langto);
            var to = strbundle.getString("foxlingo.to").replace(/&nbsp;/g," ").replace(/_/g," ");
            var langtoLabel = strbundle.getString("foxlingo.language." + langto);
            var translatorsLabel = strbundle.getString("foxlingo.translator." + translator);
            txt += to + langtoLabel + space + openp + translatorsLabel;
            if (Foxlingo.Translation.isPairBeta(langfrom, langto, translator, true))
                txt += space + strbundle.getString("foxlingo.text.beta");
        }
        txt += strbundle.getString("foxlingo.closep");
        element.setAttribute("image", "chrome://foxlingo/skin/flags-s/" + flag);
        element.setAttribute("style", "margin: -2px 0px -2px 0px;");
        element.setAttribute("label", txt);
        element.setAttribute("tooltiptext", txt);
    }
    
    function doesTranslatorSupportPair(langfrom, langto, translator) {
        var languagep1 = Foxlingo.Utils.changeLanguage(langfrom, "shortName");
        var languagep2 = Foxlingo.Utils.changeLanguage(langto, "shortName");
        var translatorPairs = Foxlingo.Translation.getTranslatorArray(translator);
        var hasLang1 = false;
        var hasLang2 = false;
        for each (var translatorPair in translatorPairs) {
            if (translatorPair==(languagep1 + "-" + languagep2))
                return true;
            if (translatorPair==languagep1)
                hasLang1 = true;
                
            if (translatorPair==languagep2 && languagep2!="so")
                hasLang2 = true;
            
            if (hasLang1 && hasLang2)
                return true;
        }
        return false;
    }
    

    return pub;
}();
