/*
 * Version: MPL v. 1.1
 *
 * The contents of this file are subject to the MPL License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/MPL-1.1.txt
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FoxLingo.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */

Foxlingo.Options.ToolbarFlags = function() {
    var pub = {};


    //public functions
    pub.updateToolbarFlagsOption = function() {
        var temp = document.getElementById('toolbarflags');
        if (!temp) 
            return;    

        pub.setToolbarFlagsOption(!temp.checked);        
    };

    pub.setToolbarFlagsOption = function(boolVal) {
        Foxlingo.Options.setOption('toolbarflagsoptions', boolVal);
    };
    
    pub.openToolbarFlagsDialog = function() {
        window.openDialog('chrome://foxlingo/content/toolbarflags.xul', 'toolbarflags', 'centerscreen,chrome,modal,resizable=yes');
    };
    
    pub.saveToolbarFlags = function(sender) {
        if (sender) { // only if being sent by saveoptions()
            for (var language in Foxlingo.Languages) {
                if (Foxlingo.isAvailableLanguageFrom(language)) {
                    var tempPref = Foxlingo.session[language + '-toolbartemp'];
                    Foxlingo.Prefs.setBoolPref(language + '-toolbar', tempPref);
                }
            }
            if (Foxlingo.Prefs.getCharPref("firsttimetoolbarflags")=='falsetemp')
                Foxlingo.Prefs.setCharPref('firsttimetoolbarflags', 'falsefinal');            
        }
        Foxlingo.Toolbar.Flags.populateToolbarFlags();
    };


    return pub;
}();
