/*
 * Version: MPL v. 1.1
 *
 * The contents of this file are subject to the MPL License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/MPL-1.1.txt
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FoxLingo.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */

Foxlingo.Prefs = function() {
    var pub = {};

    //private members
    var mFlPref;
    var mFlPrefs;
    
    //public constants
    pub.TEMPINST = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("tempInst.");

    //public functions
    pub.init = function() {
        if (!Foxlingo.session.flPrefs)
            Foxlingo.session.flPrefs = {};

        mFlPref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("foxlingo.");
        mFlPrefs = Foxlingo.session.flPrefs;
    };
    
    pub.getCharPref = function(pref, dontUseCache) {
        var pref = getPref("Char", pref, dontUseCache);
        if (!pref)
            pref = "";
        return pref;
    };

    pub.setCharPref = function(pref, val) {
        setPref("Char", pref, val);
    };

    pub.getIntPref = function(pref, dontUseCache) {
        return getPref("Int", pref, dontUseCache);
    };

    pub.setIntPref = function(pref, val) {
        setPref("Int", pref, val);
    };

    pub.getBoolPref = function(pref, dontUseCache) {
        return getPref("Bool", pref, dontUseCache);
    };

    pub.setBoolPref = function(pref, val) {
        setPref("Bool", pref, val);
    };


    //private functions
    function getPref(typeStr, pref, dontUseCache) {
        if (mFlPrefs && (dontUseCache || !mFlPrefs.hasOwnProperty(pref))) {
            try {
                mFlPrefs[pref] = mFlPref["get" + typeStr + "Pref"](pref); 
            } catch (e) {
                Foxlingo.Utils.debugException(e);
            }
        }
        if (mFlPrefs && mFlPrefs[pref])
            return mFlPrefs[pref];
    }

    function setPref(typeStr, pref, val) {
        try {
            mFlPrefs[pref] = mFlPref["set" + typeStr + "Pref"](pref, val); 
        } catch (e) {
            Foxlingo.Utils.debugException(e);
        }
        mFlPrefs[pref] = val;
    }

    return pub;
}();
