/*
 * Version: MPL v. 1.1
 *
 * The contents of this file are subject to the MPL License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/MPL-1.1.txt
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FoxLingo.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */

Foxlingo.Search.Geo = function() {
    var pub = {};


    //public functions
    pub.updateGeoCombinedSearch = function(event, type) {
        var combined = document.getElementById("Foxlingo_search-geographic-item");
        if (!combined)
            return;
        var geoSearchLang = type.replace(/ixquickgeo/i, '');
        geoSearchLang = geoSearchLang.toLowerCase();
        if (geoSearchLang=="us")
            geoSearchLang = "english";
        if (geoSearchLang=="uk")
            geoSearchLang = "english2";
        
        Foxlingo.session.geoSearchType = type;
        
        combined.setAttribute("image", "chrome://foxlingo/skin/flags-s/" + geoSearchLang + ".png");
        combined.setAttribute("searchType", type);
        Foxlingo.Search.prepareSearch(event, type);
    };
    
    pub.geoCombinedSearch = function(event) {
        var combined = document.getElementById("Foxlingo_search-geographic-item");
        if (!combined)
            return;
        if (Foxlingo.session.geoSearchType)
            Foxlingo.Search.prepareSearch(event, Foxlingo.session.geoSearchType);
    };
    
    pub.geoSearchMenuButton = function(event) {
        var combined = document.getElementById("Foxlingo_search-geographic-item");
        var searchMenu = document.getElementById("Foxlingo_Combined-Popup");    
        if (!combined || !searchMenu) return;
        if (Foxlingo.session.geoSearchType) {
            searchMenu.hidePopup();    
            Foxlingo.Search.prepareSearch(event, Foxlingo.session.geoSearchType);
        }
    };
    
    pub.initGeoCombinedSearch = function() {
        var combined = document.getElementById("Foxlingo_search-geographic-item");
        if (!combined)
            return;

        if (!Foxlingo.session.geoSearchType) {
            combined.setAttribute("image", "chrome://foxlingo/skin/geosearch.png");
            return;
        }

        var geoSearchLang = type.replace(/ixquickgeo/i, '');
        geoSearchLang = geoSearchLang.toLowerCase();
        if (geoSearchLang=="us")
            geoSearchLang = "english";
        if (geoSearchLang=="uk")
            geoSearchLang = "english2";
            
        combined.setAttribute("image", "chrome://foxlingo/skin/flags-s/" + geoSearchLang + ".png");
        combined.setAttribute("searchType", Foxlingo.session.geoSearchType);
    };
    

    return pub;
}();
