/*
 * Version: MPL v. 1.1
 *
 * The contents of this file are subject to the MPL License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/MPL-1.1.txt
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FoxLingo.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */

Foxlingo.Service = function() {
    var pub = {};

    //public functions
    pub.doesServiceUseSpecialSelection = function(service) {
        var services = ['wikipedia', 'webster1828', 'thefreedictionary', 'yourdictionary', 'answers', 'onelook', 'onelookreversedictionary', 'britannica', 'acronymfinder',
                        'rhymezone', 'etymonline', 'pcwebopedia', 'hyperdictionary', 'nearrhyme', 'medlineplus', 'medicinenet', 'pantheon', 'urbandictionary', 
                        'googleli', 'eidetica', 'promtspellcheckingenglish', 'promtspellcheckingfrench', 'promtspellcheckinggerman',
                        'promtspellcheckingitalian', 'promtspellcheckingportuguese', 'promtspellcheckingrussian', 'promtspellcheckingspanish', 'babylon', 'bbcnews',
                        'voycabulary', 'ultralingua', 'flickr', 'googlemaps', 'stumbleupon', 'delicious', 'shopping', 'ebay', 'imdb', 'yubnub', 'clusty',
                        'brainboost', 'onlineconversion', 'speegle', 'accuweather', 'googlefinance', 'yahoofinance', 'googlevideo', 'metacafe', 'youtube', 'dailymotion',
                        'ifilm', 'veoh', 'maniatv'];
        return (services.indexOf(service)!=-1);
    };
    
    pub.getServiceUrl = function(service) {
        switch (service) {
            case "linkular": return 'http://www.linkular.com/';
            case "wikipedia": return 'http://www.wikipedia.org/';
            case "webster1828": return 'http://1828.mshaffer.com/';
            case "webstersonlinedictionary": return 'http://www.websters-online-dictionary.org/';
            case "mw": return 'http://www.m-w.com/';
            case "thefreedictionary": return 'http://www.thefreedictionary.com/';
            case "yourdictionary": return 'http://www.yourdictionary.com/languages.html';
            case "answers": return 'http://www.answers.com/';
            case "onelook": return 'http://www.onelook.com/';
            case "onelookreversedictionary": return 'http://www.onelook.com/reverse-dictionary.shtml';
            case "britannica": return 'http://www.britannica.com/';
            case "acronymfinder": return 'http://www.acronymfinder.com/';
            case "anagramsite": return 'http://www.anagramsite.com/';
            case "lexfn": return 'http://www.lexfn.com/';
            case "rhymezone": return 'http://www.rhymezone.com/';
            case "etymonline": return 'http://www.etymonline.com/';
            case "pcwebopedia": return 'http://www.webopedia.com/';
            case "hyperdictionary": return 'http://www.hyperdictionary.com/';
            case "nearrhyme": return 'http://www.nearrhyme.com/';
            case "medlineplus": return 'http://www.medlineplus.gov/';
            case "medicinenet": return 'http://www.medicinenet.com/';
            case "pantheon": return 'http://www.pantheon.org/';
            case "urbandictionary": return 'http://www.urbandictionary.com/';
            case "allwords": return 'http://www.allwords.com/';
            case "sprawk": return 'http://www.sprawk.com/';
            case "dicts": return 'http://www.dicts.info/';
            case "verbix": return 'http://www.verbix.com/webverbix/index.asp';
            // Other Language Services
            case "gate2home": return 'http://www.gate2home.com/';
            case "babylon": return 'http://online.babylon.com/combo/index.html';
            case "fonetiks": return 'http://www.fonetiks.org/';
            case "bbcnews": return 'http://www.bbc.co.uk/worldservice/languages/index.shtml';
            case "unhchr": return 'http://www.ohchr.org/EN/UDHR/Pages/Introduction.aspx';
            case "nationalholidays": return 'http://www.gts-translation.com/nationalholidays/';
            case "textalyserurl": return 'http://textalyser.net/';
            case "worldlingoemailtranslator": return 'http://www.worldlingo.com/en/products/email_translator_form.html';
            case "promptgomail": return 'http://www.online-translator.com/gomail.asp?lang=en';
            case "alphabettmema": return 'http://alphabet.tmema.org/applet.html';
            case "israelfree": return 'http://www.israelfree.com/trip.asp';
            // Text-to-Speech
            case "actor": return 'http://tts.loquendo.com/ttsdemo/default.asp?page=id&language=en';
            case "verbio": return 'http://www.verbio.com/webverbio3/html/demos_ttsonline.php';
            case "oddcast": return 'http://www.oddcast.com/home/demos/tts/tts_example.html?sitepal';
            case "mary": return 'http://mary.dfki.de/online-demos';
            case "cepstral": return 'http://www.cepstral.com/cgi-bin/demos/general';
            case "syvum": return 'http://www.syvum.com/text_to_speech/';
            case "acapela": return 'http://demo.acapela-group.com/';
            case "linguatec": return 'http://www.linguatec.net/';
            case "att": return 'http://www.research.att.com/~ttsweb/tts/demo.php';
            case "eurocosmtexttospeech": return 'http://www.eurocosm.com/Eurocosm/AppEC/Pdcd/Quicktools/QuicktoolsGB.asp';
            case "sinovoice": return 'http://www.sinovoice.com.cn/english/tiyan.html';
            case "pollyglotto": return 'http://www.pollyglotto.com/index8.php';
            // Language Identification
            case "googleli": return 'http://translate.google.com/translate_t#auto|en';
            case "eidetica": return 'http://www.eidetica.com/services/guesser';
            case "lexicoolg": return 'http://www.lexicool.com/language-identifier-guesser.asp';
            case "talenknobbel": return 'http://www.fuzzums.nl/talenknobbel/';
            case "textcat": return 'http://odur.let.rug.nl/~vannoord/TextCat/Demo/textcat.html';
            case "xerox": return 'http://www.xrce.xerox.com/competencies/content-analysis/tools/guesser.en.html';
            case "complingone": return 'http://complingone.georgetown.edu/~langid/';
            case "languageidentifier": return 'http://www.languageidentifier.com/';
            case "petamemlangident": return 'http://nlp.petamem.com/en/langident.cgi';
            // Spellcheck
            // Multilingual
            case "promtspellcheckingenglish": return 'http://www.online-translator.com/text.asp?&lang=en&direction=ef';
            case "promtspellcheckingfrench": return 'http://www.online-translator.com/text.asp?&lang=en&direction=fe';
            case "promtspellcheckinggerman": return 'http://www.online-translator.com/text.asp?&lang=en&direction=ge';
            case "promtspellcheckingitalian": return 'http://www.online-translator.com/text.asp?&lang=en&direction=ie';
            case "promtspellcheckingportuguese": return 'http://www.online-translator.com/text.asp?&lang=en&direction=pe';
            case "promtspellcheckingrussian": return 'http://www.online-translator.com/text.asp?&lang=en&direction=re';
            case "promtspellcheckingspanish": return 'http://www.online-translator.com/text.asp?&lang=en&direction=se';
            case "petamem": return 'http://nlp.petamem.com/en/spellcheck.cgi';
            case "orangoo": return 'http://orangoo.com/spell/';
            case "madcoffee": return 'http://spellcheck.madcoffee.com/';
            case "javascriptspellcheck": return 'http://www.javascriptspellcheck.com/demo_multilingual.asp';
            case "bonjourspellcheck": return 'http://www.bonjour.com/french_dictionary.htm';
            case "lenguaje": return 'http://www.lenguaje.com/english/';
            case "thesolutioncafe": return 'http://www.thesolutioncafe.com/public-spell-checker.html';
            case "translationparalink": return 'http://translation.paralink.com/?clientid=IDABXORB&afid=14645';
            // English
            case "siteowner": return 'http://siteowner.bcentral.com/sitecheck.cfm';
            case "chxo": return 'http://chxo.com/scripts/spellcheck.php';
            case "design215": return 'http://www.design215.com/toolbox/spellcheck.php';
            case "jacuba": return 'http://spell.jacuba.com/tryit.html';
            case "telerik": return 'http://www.telerik.com/demos/aspnet/Spell/Examples/WhatsNew/DefaultCS.aspx';
            case "spellchecknet": return 'http://www.spellcheck.net/';
            case "spellex": return 'http://spellex.com/spellcheck.htm';
            case "spellexmedical": return 'http://spellex.com/speller.htm';
            case "xde": return 'http://xde.net/xdespellchecker/editor/htmledit.htm';
            // Other languages
            case "kyprosorthographic": return 'http://www.kypros.org/cgi-bin/orthographic/';
            case "kwuntung": return 'http://www.kwuntung.net/check/';
            case "slicorrector": return 'http://sli.uvigo.es/corrector/index_en.html';
            case "flip": return 'http://www.flip.pt/Produtos/FLiPOnline/tabid/96/Default.aspx';
            case "bbcwelshspeller": return 'http://www.bbc.co.uk/cgi-bin/wales/learnwelsh/welsh_speller.pl';
            case "cswelshspellchecker": return 'http://www.cs.cf.ac.uk/fun/welsh/SpellChecker.html';
    
            // Learning languages
            // Multilingual
            case "languagebuddy": return 'http://www.language-buddy.com/';
            case "lingup": return 'http://www.lingup.com/';
            case "phrasebase": return 'http://www.phrasebase.com/english/';
            case "lingozone": return 'http://www.lingozone.com/';
            case "wikibookslanguagesbookshelf": return 'http://en.wikibooks.org/wiki/Wikibooks:Languages_bookshelf';
            case "wikipediacommonphrases": return 'http://en.wikipedia.org/wiki/User:Christopher_Sundita/List_of_common_phrases_in_various_languages';
            case "polyglotlearnlanguage": return 'http://www.polyglot-learn-language.com/';
            case "travlang": return 'http://travlang.com/languages/';
            case "unilang": return 'http://home.unilang.org/main/index2.php';
            case "fsilanguagecourses": return 'http://fsi-language-courses.com/';
            case "pdictionary": return 'http://www.pdictionary.com/';
            case "mylanguageexchange": return 'http://www.mylanguageexchange.com/';
            case "bbclanguages": return 'http://www.bbc.co.uk/languages/';
            case "eurocosm": return 'http://www.eurocosm.com/';
            case "languagegames": return 'http://www.languagegames.org/';
            case "seasite": return 'http://www.seasite.niu.edu/';
            // English
            case "wordsmith": return 'http://www.wordsmith.org/words/today.html';
            case "dailygrammar": return 'http://www.dailygrammar.com/';
            case "englishonline": return 'http://www.english-online.org.uk/';
            case "freeenglish": return 'http://www.free-english.com/';
            case "1language": return 'http://www.1-language.com/';
            case "superteach": return 'http://webnz.co.nz/checkers/free2.html';
            case "hgpublishing": return 'http://www.hgpublishing.com/FreeGrammarHelp.html';
            case "etymologic": return 'http://www.etymologic.com/';
            case "funbrain": return 'http://www.funbrain.com/words.html';
            case "lapasserelle": return 'http://www.lapasserelle.com/lm/exercices/games.page.html';
            // Other languages 1
            case "afrikaansus": return 'www.afrikaans.us';
            case "babelarabic": return 'http://lexicorient.com/babel/arabic/index.htm';
            case "buber": return 'http://www.buber.net/Basque/Euskara/';
            case "learnbulgarian": return 'http://learnbulgarian.hit.bg/';
            case "hrvatska": return 'http://www.hr/hrvatska/language/';
            case "bohemica": return 'http://www.bohemica.com/index.php';
            case "tscasdanish": return 'http://www.geocities.com/SiliconValley/Horizon/1284/dansk/';
            case "speakdanish": return 'http://www.speakdanish.dk/';
            case "enhavo": return 'http://wwwtios.cs.utwente.nl/esperanto/hypercourse/inhoud.html';
            case "esperantoca": return 'http://www.esperanto.ca/kurso/home.htm';
            case "venla": return 'http://users.utu.fi/jmkark/kieli/index.html';
            case "finnishgrammar": return 'http://www.uta.fi/~km56049/finnish/';
            case "greece": return 'http://www.greece.org/gr-lessons/';
            case "kypros": return 'http://www.kypros.org/LearnGreek/';
            case "hungarotips": return 'http://www.hungarotips.com/hungarian/';
            case "mimir": return 'http://www.samkoma.com/mimir/mimir.htm';
            case "icelandiconline": return 'http://icelandic.hi.is/';
            // Other languages 2
            case "expat": return 'http://www.expat.or.id/info/bahasa.html';
            case "unification": return 'http://www.interedu.go.kr/';
            case "rkikbs": return 'http://www.learn-korean.net/';
            case "hhhh": return 'http://www.hhhh.org/perseant/libellus/aides/allgre/';
            case "humanum": return 'http://humanum.arts.cuhk.edu.hk/Lexis/Wheelock-Latin/';
            case "morsecodetranslator": return 'http://morsecode.scphillips.com/jtranslator.html';
            case "norskklassen": return 'http://frodo.bruderhof.com/norskklassen/';
            case "sofn": return 'http://www.sofn.com/norwegian_culture/languagelessons_index.jsp';
            case "easypersian": return 'http://www.easypersian.com/';
            case "golem": return 'http://golem.umcs.lublin.pl/users/ppikuta/lessons/less0.htm';
            case "grzegorj": return 'http://grzegorj.w.interia.pl/kurs/index.html';
            case "polishslavic": return 'http://polish.slavic.pitt.edu/';
            case "romanianlessons": return 'http://www.geocities.com/romanianlessons/';
            case "masterrussian": return 'http://masterrussian.com/';
            case "personalpsu": return 'http://www.personal.psu.edu/faculty/a/d/adr10/swedish.html';
            case "bjornengdahl": return 'http://www.geocities.com/Athens/Acropolis/1290/';
            case "caliarizona": return 'http://cali.arizona.edu/maxnet/tur/';
            case "turkishclass": return 'http://www.turkishclass.com/';
            // Chinese
            case "wkuedu": return 'http://www.wku.edu/~yuanh/AudioChinese/';
            case "chinesetools": return 'http://www.chinese-tools.com/learn/chinese';
            case "zapchinese": return 'http://www.zapchinese.com/';
            case "melnyks": return 'http://www.melnyks.com/';
            // Dutch
            case "hengeveld": return 'http://web.hengeveld.com/dutch/';
            case "thinkdifferent": return 'http://www.learndutch.org/';
            case "forbeginners": return 'http://www.forbeginners.info/dutch/basics.htm';
            case "learndutchnu": return 'http://www.learndutch.nu/';
            // French
            case "frenchtutorial": return 'http://www.frenchtutorial.com/';
            case "learnfrenchinboston": return 'http://www.learnfrenchinboston.com/freeLessons/freelessons.cfm';
            case "frenchassistant": return 'http://www.frenchassistant.com/default.asp';
            case "bonjour": return 'http://www.bonjour.com/';
            // German
            case "deutschlernen": return 'http://www.deutsch-lernen.com/';
            case "exeter": return 'http://www.ex.ac.uk/german/abinitio/index.html';
            case "germanfortravellers": return 'http://www.germanfortravellers.com/';
            // Hebrew
            case "akhlah": return 'http://www.akhlah.com/';
            case "foundationstone": return 'http://foundationstone.com.au/';
            case "hebrewverbs": return 'http://www.hebrew-verbs.co.il/';
            case "zigzagworld": return 'http://www.zigzagworld.com/hebrewforme/';
            case "ivritbkalut": return 'http://perso.orange.fr/babel-site/ivrit.htm';
            // Hindi
            case "nyu": return 'http://www.nyu.edu/gsas/dept/mideast/hindi/';
            case "philae": return 'http://philae.sas.upenn.edu/Hindi/hindi.html';
            case "ncsu": return 'http://www.ncsu.edu/project/hindi_lessons/lessons.html';
            // Japanese
            case "japancast": return 'http://www.japancast.net/';
            case "japaneseonline": return 'http://www.japanese-online.com/';
            case "writejapan": return 'http://members.aol.com/writejapan/#katakana';
            // Spanish
            case "businessspanish": return 'http://www.businessspanish.com/';
            case "spanishkit": return 'http://www.spanish-kit.net/';
            case "studyspanish": return 'http://studyspanish.com/';
            case "elemadrid": return 'http://www.elemadrid.com/spanish_language.htm';
            // Sign languages
            case "worldsig": return 'http://www.deafblind.com/worldsig.html';
            case "lifeprint": return 'http://www.lifeprint.com/';
            case "lessontutor": return 'http://www.lessontutor.com/ASLgenhome.html';
            case "asldictionary": return 'http://www.masterstech-home.com/The_Library/ASL_Dictionary_Project/ASL_Tables/A.html';
            case "britishsign": return 'http://www.british-sign.co.uk/learnbslsignlanguage/';
            case "signwriting": return 'http://signwriting.org/about/';
            // URL translators (click a word to see translation)
            case "voycabulary": return 'http://www.voycabulary.com/p.cgi?refalias=eng_dict_mw&display=win&texturl=';
            case "ultralingua": return 'http://www.ultralingua.net/';
            case "rikai": return 'http://www.rikai.com/perl/HomePage.pl?Language=Ja';
            case "babelsheep": return 'http://www.topfun.co.uk/babelsheep/';
            // Psyclops
            case "ppimp":
            case "pskinhead":
            case "phacker":
            case "psmurf":
            case "pozzie":
            case "pcockney":
            case "predneck": return 'http://www.psyclops.com/translator/';
            // Dialectizer
            case "dredneck":
            case "djive":
            case "dcockney":
            case "delmerfudd":
            case "dswedishchef":
            case "dmoron":
            case "dpiglatin":
            case "dhacker": return 'http://rinkworks.com/dialect/';
            // Crapola
            case "yoda":
            case "rot13":
            case "ayb":
            case "boston":
            case "canadian":
            case "haxor":
            case "ebonics":
            case "valley":
            case "binary":
            case "jeffk":
            case "ultraleet":
            case "martian":
            case "piglatin":
            case "smurf": return 'http://www.degraeve.com/translator.php';
            // General Language Information
            case "learnalanguage": return 'http://www.frugalfun.com/learnalanguage.html';
            case "wikipediahowtolearnalanguage": return 'http://en.wikibooks.org/wiki/How_to_learn_a_language';
            case "phoneticalphabets": return 'http://morsecode.scphillips.com/alphabet.html';
            case "voiceproblemlearning": return 'http://www.voiceproblem.org/anatomy/learning.asp';
            case "wikipedialanguage": return 'http://en.wikipedia.org/wiki/Language';
            case "wikipedialanguagebookshelf": return 'http://en.wikibooks.org/wiki/Wikibooks:Language_and_literature_bookshelf';    
            // Free Human Translation, Proofreading & Editing
            case "click2translate": return 'http://www.click2translate.com/translation_center/free_human_translations/';
            case "translateandsavespanish": return 'http://www.translateandsave.com/free-spanish-proofreading.htm';
            case "sylang": return 'http://sylang.com/en/';
            case "ardom": return 'http://www.ardom.co.il/heilot/ketura/tts/free.htm';
            case "freelang": return 'http://www.freelang.net/translation/index.html';
            case "writing": return 'http://www.writing.com/main/forums/item_id/326885';
            case "cucumis": return 'http://www.cucumis.org/';
            case "freelocalization": return 'http://www.freelocalization.com/';
            case "freetranslator": return 'http://www.free-translator.com/forum.html';
            // Professional Translation
            case "worldlingopt": return 'http://www.worldlingo.com/';
            case "globalpt": return 'http://gts-translation.com/';
            case "tranexppt": return 'https://www.tranexp.com/win/HumanTran.htm';        
            // Other Services
            case "ixquickphonesearch": return 'http://eu.ixquick.com/eng/phone.html';
            case "flickr": return 'http://www.flickr.com/';
            case "gchart": return 'http://www.gchart.com/';
            case "googlemaps": return 'http://maps.google.com/';
            case "stumbleupon": return 'http://www.stumbleupon.com/';
            case "delicious": return 'http://del.icio.us/';
            case "shopping": return 'http://www.shopping.com/';
            case "ebay": return 'http://www.ebay.com/';
            case "imdb": return 'http://www.imdb.com/';
            case "findsounds": return 'http://www.findsounds.com/';
            case "soundclick": return 'http://www.soundclick.com/';
            case "talkbackwards": return 'http://www.talkbackwards.com/';
            case "creativecommons": return 'http://search.creativecommons.org/';
            case "yubnub": return 'http://yubnub.org/';
            case "clusty": return 'http://clusty.com/';
            case "brainboost": return 'http://www.brainboost.com/';
            case "onlineconversion": return 'http://www.onlineconversion.com/';
            case "librivox": return 'http://www.librivox.org/';
            case "speegle": return 'http://us.speegle.co.uk/';
            case "googlefinance": return 'http://finance.google.com/';
            case "yahoofinance": return 'http://finance.yahoo.com/';
            case "accuweather": return 'http://wwwa.accuweather.com/';
            // Videos
            case "googlevideo": return 'http://video.google.com/';
            case "metacafe": return 'http://www.metacafe.com/';
            case "youtube": return 'http://www.youtube.com/';
            case "dailymotion": return 'http://www.dailymotion.com/';
            case "ifilm": return 'http://www.ifilm.com/';
            case "veoh": return 'http://www.veoh.com/';
            case "maniatv": return 'http://www.maniatv.com/';
            default: throw Foxlingo.Utils.FoxlingoExceptionUnhandledCase;
        }
    };
    
    pub.getNonBlankServiceUrl = function(service, url) {
        var serviceUrl = pub.getServiceUrl(service);
        switch (service) {
            // Other Language Services
            case "textalyserurl": return serviceUrl + '?q=' + url;
            // English
            case "siteowner": return 'http://www.siteowner.com/system/socheckspelling.cfm?url=' + url;
            // URL translators (click a word to see translation)
            case "voycabulary": return serviceUrl + url;
            case "babelsheep": return serviceUrl + 'index.php?type=url&url=' + url;
            // Psyclops
            case "ppimp": return serviceUrl + 'translator.cgi?url=' + url + '&mode=pimp';
            case "pskinhead": return serviceUrl + 'translator.cgi?url=' + url + '&mode=skin';
            case "phacker": return serviceUrl + 'translator.cgi?url=' + url + '&mode=hacker';
            case "psmurf": return serviceUrl + 'translator.cgi?url=' + url + '&mode=smurf';
            case "pozzie": return serviceUrl + 'translator.cgi?url=' + url + '&mode=oz';
            case "pcockney": return serviceUrl + 'translator.cgi?url=' + url + '&mode=cock';
            case "predneck": return serviceUrl + 'translator.cgi?url=' + url + '&mode=redneck';
            // Dialectizer
            case "dredneck": return serviceUrl + 'dialectp.cgi?dialect=redneck&inside=1&url=' + url;
            case "djive": return serviceUrl + 'dialectp.cgi?dialect=jive&inside=1&url=' + url;
            case "dcockney": return serviceUrl + 'dialectp.cgi?dialect=cockney&inside=1&url=' + url;
            case "delmerfudd": return serviceUrl + 'dialectp.cgi?dialect=elmerfudd&inside=1&url=' + url;
            case "dswedishchef": return serviceUrl + 'dialectp.cgi?dialect=swedishchef&inside=1&url=' + url;
            case "dmoron": return serviceUrl + 'dialectp.cgi?dialect=moron&inside=1&url=' + url;
            case "dpiglatin": return serviceUrl + 'dialectp.cgi?dialect=piglatin&inside=1&url=' + url;
            case "dhacker": return serviceUrl + 'dialectp.cgi?dialect=hacker&inside=1&url=' + url;
            // Crapola
            case "yoda": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=yoda&url=' + encodeURIComponent(url);
            case "rot13": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=rot13&url=' + encodeURIComponent(url);
            case "ayb": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=ayb&url=' + encodeURIComponent(url);
            case "boston": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=boston&url=' + encodeURIComponent(url);
            case "canadian": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=canadian&url=' + encodeURIComponent(url);
            case "haxor": 
                var flUrl = url;
                if (flUrl[flUrl.length - 1]=="/")
                    flUrl = flUrl.substr(0, flUrl.length - 2);
                return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=haxor&url=' + encodeURIComponent(flUrl) + "&w=";
            case "ebonics": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=ebonics&url=' + encodeURIComponent(url);
            case "valley": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=valley&url=' + encodeURIComponent(url);
            case "binary": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=binary&url=' + encodeURIComponent(url);
            case "jeffk": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=jeffk&url=' + encodeURIComponent(url);
            case "ultraleet": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=ultraleet&url=' + encodeURIComponent(url);
            case "martian": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=martian&url=' + encodeURIComponent(url);
            case "piglatin": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=piglatin&url=' + encodeURIComponent(url);
            case "smurf": return 'http://www.degraeve.com/cgi-bin/babel.cgi?d=smurf&url=' + encodeURIComponent(url);
            default: return '';
        }
    };

    pub.getServiceSelectionUrl = function(service, selection) {
        var serviceUrl = pub.getServiceUrl(service);
        switch (service) {
            // Dictionaries & Encyclopedias
            case "wikipedia": return serviceUrl + 'wiki/' + selection;
            case "webster1828": return serviceUrl + 'd/search/word,' + selection;
            case "webstersonlinedictionary": return serviceUrl + 'definition/' + selection;
            case "mw": return serviceUrl + 'dictionary/' + selection;
            case "thefreedictionary": return serviceUrl + selection;
            case "yourdictionary": return "http://www.yourdictionary.com/search?ydQ=" + selection + '&area=entries&x=0&y=0';
            case "answers": return serviceUrl + selection;
            case "onelook": return serviceUrl + '?w=' + selection + '&ls=a';
            case "onelookreversedictionary": return 'http://www.onelook.com/?w=*&loc=revfp2&clue=' + selection;
            case "britannica": return serviceUrl + 'search?query=' + selection + '&ct=&searchSubmit.x=0&searchSubmit.y=0';
            case "acronymfinder": return serviceUrl + 'af-query.asp?Acronym=' + selection + '&Find=find&string=exact';
            case "rhymezone": return serviceUrl + 'r/rhyme.cgi?Word=' + selection + '&typeofrhyme=perfect&org1=syl&org2=l';
            case "etymonline": return serviceUrl + 'index.php?search=' + selection + '&searchmode=none';
            case "pcwebopedia": return 'http://search.internet.com/www.webopedia.com?IC_QueryText=' + selection + '&IC_QueryDatabase=www.webopedia.com';
            case "hyperdictionary": return serviceUrl + 'search.aspx?define=' + selection;
            case "nearrhyme": return serviceUrl + 'index.jsp?w=' + selection + '&rlsEmph=on&rlsc=n&rlsv=c&r2lsEmph=on&r2lsc=n&r2lsv=c&afsEmph=on&afsc=i&afsv=i&a2sEmph=on&a2sc=i&a2sv=i';
            case "medlineplus": return 'http://www2.merriam-webster.com/cgi-bin/mwmednlm?book=Medical&va=' + selection;
            case "medicinenet": return serviceUrl + 'script/main/srchcont.asp?src=' + selection + '&op=mm';
            case "pantheon": return serviceUrl + 'cgi-bin/search.pl?nocpp=1&Realm=mythica&fa=0&Terms=' + selection;
            case "urbandictionary": return serviceUrl + 'define.php?term=' + selection;
            // Language Identification
            case "googleli": return serviceUrl + '|' + selection;
            case "eidetica": return serviceUrl + '?string=' + selection;
            // Other Language Services
            case "promtspellcheckingenglish":
            case "promtspellcheckingfrench":
            case "promtspellcheckinggerman":
            case "promtspellcheckingitalian":
            case "promtspellcheckingportuguese":
            case "promtspellcheckingrussian":
            case "promtspellcheckingspanish": return serviceUrl + '&status=translate&source=' + selection;
            case "babylon": return 'http://info.babylon.com/cgi-bin/info.cgi?word=' + selection + '&lang=&ot=2&layout=combo2.html&n=10&keeplang=0';
            case "bbcnews": return 'http://search.bbc.co.uk/search?uri=%2Fworldservice%2Flanguages%2Findex.shtml&go=toolbar&q=' + selection;
            // URL translators (click a word to see translation)
            case "voycabulary": return serviceUrl + selection;
            case "ultralingua": return serviceUrl + 'index.html?action=define&nv=0&text=' + selection + '&service=&searchtype=stemmed';
            // Other Services
            case "flickr": return serviceUrl + 'search/?q=' + selection;
            case "googlemaps": return serviceUrl + '?q=' + selection;
            case "stumbleupon": return serviceUrl + '?q=' + selection;
            case "delicious": return serviceUrl + selection;
            case "shopping": return 'http://www3.shopping.com/xFS?KW=' + selection;
            case "ebay": return serviceUrl + selection + '_W0QQfromZR40';
            case "imdb": return serviceUrl + selection;
            case "yubnub": return serviceUrl + 'parser/parse?command=' + selection;
            case "clusty": return serviceUrl + 'search?query=' + selection;
            case "brainboost": return serviceUrl + 'search.asp?Q=' + selection + '&Submit=Ask';
            case "onlineconversion": return serviceUrl + 'search/search.cgi?q=' + selection + '&c=1&f=1';
            case "speegle": return serviceUrl + 'search.php?q=' + selection + 'voice=1&v=1';
            case "googlefinance": return serviceUrl + 'finance?q=' + selection + '&hl=en';
            case "yahoofinance": return serviceUrl + 'q/cq?d=v1&s=' + selection;
            case "accuweather": return serviceUrl + 'us-city-list.asp?partner=accuweather&zipcode=' + selection;
            // Videos
            case "googlevideo": return serviceUrl + 'videosearch?q=' + selection;
            case "metacafe": return serviceUrl + 'tags/' + selection + '/';
            case "youtube": return serviceUrl + 'results?search=' + selection + '&search_type=search_videos&search=Search';
            case "dailymotion": return serviceUrl + 'search?query=' + selection;
            case "ifilm": return serviceUrl + 'search?query=' + selection;
            case "veoh": return serviceUrl + 'search.html?query=' + selection + '&numResults=20&x=0&y=0';
            case "maniatv": return serviceUrl + 'channelGuide.html?submit=submit&query=' + selection + '&x=0&y=0&q_type=any';
            default: throw Foxlingo.Utils.FoxlingoExceptionUnhandledCase;
        }
    };
    

    return pub;
}();
