/*
 * Version: MPL v. 1.1
 *
 * The contents of this file are subject to the MPL License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/MPL-1.1.txt
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FoxLingo.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */

Foxlingo.Status = function() {
    var pub = {};

    //private properties
    var mTabStatusUrls = [];


    //public functions
    pub.displayTabStatus = function(tabUrl) {
        var tabStatus = getTabStatus(tabUrl);

        window._content.status = tabStatus;
    };

    pub.showStatusMessage = function(msg, isError, targetUrl) {
        if (isError) {
            alert(msg);
            return;
        }
        
        if (targetUrl) {
            addToStatusList(msg, targetUrl);
            if (targetUrl!=Foxlingo.Utils.getCurrentDocument().URL)
                return;
        }
        window._content.status = msg;
    };
    
    pub.restoreStatusMessage = function() {
        window._content.status = '';
    };
    

    //private functions
    function addToStatusList(statusText, tabUrl) {
        mTabStatusUrls.push(tabUrl);
    }
    
    function getTabStatus(tabUrl) {
        if (mTabStatusUrls.indexOf(tabUrl)!=-1)
                return url;
        return null;
    }


    return pub;
}();
