/*
 * Version: MPL v. 1.1
 *
 * The contents of this file are subject to the MPL License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/MPL-1.1.txt
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FoxLingo.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */

Foxlingo.Translation.Auto = function() {
    var pub = {};

    //public properties
    pub.backToOriginalList = [];
    pub.alreadySentList = [];


    //public functions
    pub.autotranslateFrom = function(langFrom, isTextTranslation, clickEvent) {
        var clickableWebtrans = Foxlingo.Prefs.getBoolPref("clickablewebtrans");
        if (!clickableWebtrans)
            return;
        var dlang = Foxlingo.Prefs.getCharPref("options-dlang");
        if (!langFrom)
            langFrom = "auto";
        var translator = Foxlingo.Translation.getTranslator(langFrom, dlang);
    
        if (translator && translator!='none' && isTextTranslation)
            Foxlingo.Translation.Text.translateText(langFrom, dlang, translator, false, clickEvent);
        else if (translator && translator!='none')
            Foxlingo.Translation.translateUrl(langFrom, dlang, translator);
    };
    
    pub.autoTranslate = function(langfrom, langto, translator, button, target) {
        if (target && Foxlingo.Prefs.getBoolPref("autotranslate") && pub.findRemoveBackList(target.URL))
            return;
        
        var thisUrl;
        if (!target) {
            thisUrl = Foxlingo.Utils.getCurrentDocument();
            if (thisUrl)
                thisUrl = thisUrl.URL;
        } else {
            thisUrl = target.URL;
        }
            
        if (thisUrl && ((thisUrl.substr(0,8)=='https://' && !button) ||
                        (Foxlingo.Prefs.getBoolPref("autotranslate") && 
                         (thisUrl.indexOf("ixquick.com")!=-1 || thisUrl.indexOf("search.foxlingo")!=-1) &&
                         translator!="worldlingo")))
            return;

        if (Foxlingo.Translation.isUrlTranslated(target))
            return;
        
        var autoPair = pub.getAutoPair(langfrom, langto, translator); 
        if (autoPair=="none" || autoPair=="english" || langfrom=="unknowndomain") { 
            translator = Foxlingo.Translation.getTranslator("english", langto); 
            langfrom = "english";
        } else if (autoPair!="normal" || (Foxlingo.Prefs.getBoolPref("autotranslate") && langfrom==langto)) {
            return;
        }
        if (translator=="google" && !Foxlingo.Prefs.getBoolPref("autotranslate"))
            langfrom = "auto";
        Foxlingo.Translation.translateUrl(langfrom, langto, translator, target); 
    };
    
    pub.getAutoPair = function(langfrom, langto, translator) {
        if (langfrom==langto && translator!="google")
            return "none";

        if (translator=="none") {
            if (Foxlingo.Translation.getTranslator("english", langto)=="none") 
                return "none";
            if (langto!='english') 
                return "english";
        } 
        return "normal";
    };
    
    pub.findRemoveBackList = function(urlToFind) {
        for (var i in pub.backToOriginalList) {
            if (pub.backToOriginalList[i]==urlToFind) {
                pub.backToOriginalList.splice(i, 1);
                return true;
            }
        }
        return false;
    };
    
    pub.findRemoveSentList = function(urlToFind) {
        for (var i in pub.alreadySentList) {
            if (pub.alreadySentList[i]==urlToFind) {
                pub.alreadySentList.splice(i, 1);
                return true;
            }
        }
        return false;
    };
    
    pub.findBackList = function(urlToFind) {
        return (pub.backToOriginalList.indexOf(urlToFind)!=-1);
    };
    

    return pub;
}();
