/*
 * Version: MPL v. 1.1
 *
 * The contents of this file are subject to the MPL License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/MPL-1.1.txt
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FoxLingo.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */

Foxlingo.Translation.Text = function() {
    var pub = {};

    //public functions
    pub.translateText = function(language1, language2, translator, translateRequest, clickEvent , injectionProperties) {
        var selection = "";
        var lang1 = Foxlingo.Translation.changeLanguagesToCode(Foxlingo.Utils.changeLanguage(language1, "shortName"), translator);
        var lang2 = Foxlingo.Translation.changeLanguagesToCode(Foxlingo.Utils.changeLanguage(language2, "shortName"), translator);
        if (!clickEvent && gContextMenu)
            clickEvent = gContextMenu;
        if (injectionProperties)
            selection = injectionProperties["text"];
        else if (!translateRequest && content && content.window && content.window.getSelection() && content.window.getSelection().toString().length>0)
            selection = content.window.getSelection().toString();
        else if (clickEvent && clickEvent.target && clickEvent.target.textContent)
            selection = clickEvent.target.textContent;
        else if (document.getElementById("foxlingo-search-box"))
            selection = document.getElementById("foxlingo-search-box").value;
        else if (translateRequest!='textbox')
            selection = Foxlingo.session.translatedSearchTerms;
        else if ((clickEvent || gContextMenu) && document.getElementById("Foxlingo_context-dictionary-item") && document.getElementById("Foxlingo_context-dictionary-item").word)
            selection = document.getElementById("Foxlingo_context-dictionary-item").word;
        if (translator=="google" && !injectionProperties)
            selection = selection.substr(0, 300);
            

        if (translator=="citcat") {
            if (translateRequest=="yes")
                Foxlingo.Search.Translated.translatedSearchMalay(selection, "citcat", '', lang1, lang2);
            else if (!translateRequest || translateRequest=="textbox")
                translateMalayText(selection, lang1, lang2);
            else
                Foxlingo.Search.Translated.translatedSearchMalay(newUrl, "citcat", translateRequest, lang1, lang2);
            return; 
        } else if (translator=="internostrum" && (!translateRequest || translateRequest!='textbox')) {
            translateInternosText(selection, lang1, lang2); 
            return; 
        }
        
        try {
            var newUrl = Foxlingo.Translation.getTranslationUrl(translator, lang1, lang2, '', selection.substr(0, 1300));
            if (clickEvent && translator=="worldlingo")
                newUrl = newUrl + "&f=1"
        } catch (e) {
            if (e==Foxlingo.Utils.FoxlingoExceptionEmptySelection) {
                Foxlingo.Utils.openError('ERROR_NEEDS_SELECTION');
                return;
            }
            //it's not our error so rethrow it
            throw e;
        }
        if (!newUrl) { //means the selection wasn't empty
            switch (translator) {
                case "interpret": translateAfrikaansText(selection, Foxlingo.Translation.getGlobalPair(lang1, lang2, "interpret")); return;
                case "toggletext": translateToggleTextText(selection, lang1, lang2); return; 
                case "cervantes": translateCervantesText(selection, Foxlingo.Translation.getGlobalPair(lang1, lang2, "cervantes")); return;
                case "vilnet": translateVilnetText(selection, lang1, lang2); return;
                case "translatica": translateTranslaticaText(selection, lang1 + lang2); return;
                default: break;
            }
        }
        
        if (!newUrl)
            newUrl = "none";
        if (injectionProperties)
            Foxlingo.Translation.sendTranslateRequest(newUrl, translator, translateRequest,null, injectionProperties);
        else if (clickEvent)
            window.setTimeout(function() { Foxlingo.Utils.openFoxLingoPopup(clickEvent, newUrl); }, 500);
        else if (translateRequest=="yes")
            Foxlingo.Translation.sendTranslateRequest(newUrl, translator);
        else if (translateRequest=="textbox" || !translateRequest)
            Foxlingo.Utils.openTabL(newUrl);
        else
            Foxlingo.Translation.sendTranslateRequest(newUrl, translator, translateRequest);
    };
    
    pub.getEmptySelectionTextTranslationUrl = function(translator) {
        switch (translator) {
            case "lingro": return 'http://lingro.com/';
            case "freetranslation": return 'http://www.freetranslation.com/free/';
            case "websphere": throw Foxlingo.Utils.FoxlingoExceptionEmptySelection;
            case "gencat": return 'http://traductor.gencat.cat/text.do';
            case "interpret": return 'http://interpret.co.za/';
            case "toggletext": return 'http://www.toggletext.com/';
            case "traduku": return 'http://traduku.net/';
            case "internostrum": return 'http://internostrum.com/text.php';
            case "opentrad": return 'http://www.opentrad.org/index.php?idioma=es';
            case "apertium": return 'http://xixona.dlsi.ua.es/apertium-unstable/';
            case "ask": throw Foxlingo.Utils.FoxlingoExceptionEmptySelection;
            case "cervantes": return 'http://oesi.cervantes.es/traduccionAutomatica.html';
            case "nifty": return 'http://tool.nifty.com/globalgate/';
            case "promt": return 'http://www.online-translator.com/text.asp?lang=en&direction=ef';
            case "huajian": throw Foxlingo.Utils.FoxlingoExceptionEmptySelection;
            case "vilnet": return "http://vil-net.dyndns.org/hon/textv/";
            case "elmundo": return "http://elmundo.reverso.net/textonly/default.asp";
            case "translatica" : return 'http://www.translatica.pl/';
            default: return '';
        }
    };

    pub.doesTranslatorSupportTextTranslation = function(translator) {
        var noTextTranslation = ["lingro", "bingtranslator", "ocn", "paktranslations", "promt"];
        return (noTextTranslation.indexOf(translator)==-1);
    }
    
    //private functions
    function translateVilnetText(txt, lang1, lang2) {
        var tempItem = document.getElementById("vilnetTextForm");

        tempItem.target = Foxlingo.Utils.getTarget();
        tempItem.mod.value = lang1 + "2" + lang2;
        tempItem.eng.value = Foxlingo.Utils.urlDecodeSpaces(txt);
        tempItem.submit();    
    }
    
    function translateMalayText(txt, lang1, lang2) {
        var tempItem = document.getElementById("citcatform");
        
        tempItem.target = Foxlingo.Utils.getTarget();
        var pair;
        if (lang1=="en" && lang2=="ma")
            pair = "1"; 
        else if (lang1=="ma" && lang2=="en")
            pair = "2"; 
        else if (lang1=="en" && lang2=="cn")
            pair = "3";
        tempItem.trans_language_.value = pair;
        tempItem.src_text_.value = Foxlingo.Utils.urlDecodeSpaces(txt);
        tempItem.submit();    
    }
    
    function translateAfrikaansText(txt, pair) {
        var tempItem = document.getElementById("formtext");

        tempItem.target = Foxlingo.Utils.getTarget();
        tempItem.tlangpair.value = pair;
        tempItem.text.value = Foxlingo.Utils.urlDecodeSpaces(txt);
        tempItem.submit();    
    }
    
    function translateToggleTextText(txt, lang1, lang2) {
        var tempItem = document.getElementById("toggletextTextForm");

        tempItem.target = Foxlingo.Utils.getTarget();
        tempItem.input_text.value = Foxlingo.Utils.urlDecodeSpaces(txt, true);
        if (lang1=='en')
            tempItem.langset_text.value = 'en_in';
        else
            tempItem.langset_text.value = 'in_en';
        tempItem.submit();    
    }
    
    function translateInternosText(txt, lang1, lang2) {
        var tempItem = document.getElementById("internos");

        tempItem.target = Foxlingo.Utils.getTarget();
        tempItem.quadretext.value = Foxlingo.Utils.urlDecodeSpaces(txt, true);
        if (lang1=='es')
            tempItem.direccio.value = 'es-ca';
        else
            tempItem.direccio.value = 'ca-es';
        tempItem.submit();    
    }
    
    function translateCervantesText(txt, pair) {
        var tempItem = document.getElementById("cervantes");

        tempItem.target = Foxlingo.Utils.getTarget();
        tempItem.origen.value = Foxlingo.Utils.urlDecodeSpaces(txt, true);
        tempItem.idioma.value = pair;
        tempItem.submit();    
    }
    
    function translateTranslaticaText(txt, pair) {
        var tempItem = document.getElementById("translatica");

        tempItem.target = Foxlingo.Utils.getTarget();
        tempItem.translate_text.value = Foxlingo.Utils.urlDecodeSpaces(txt, true);
        tempItem.dirTxt.value = pair;
        tempItem.submit();    
    }
    
    return pub;
}();
