/*
 * Version: MPL v. 1.1
 *
 * The contents of this file are subject to the MPL License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/MPL-1.1.txt
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FoxLingo.
 *
 * The Initial Developer of the Original Code is
 * Linkular LLC
 *
 * Portions created by the Initial Developer are Copyright (C) 2010
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */


Foxlingo.Utils = function() {
    var pub = {};

    //public properties
    //exceptions
    pub.FoxlingoExceptionEmptySelection = "FoxlingoExceptionEmptySelection";
    pub.FoxlingoExceptionUnhandledCase = "FoxlingoExceptionUnhandledCase";

    //public members
    pub.isFF = true;

    // public constants
    pub.domains = {
            english: ['com', 'net', 'org', 'uk', 'us', 'ac', 'ag', 'aq', 'au', 'bb', 'bm', 'bn', 'bs', 'bw',
                      'bz', 'ca', 'ck', 'cx', 'dm', 'edu', 'et', 'fj', 'fk', 'fm', 'gb', 'gd', 'ge', 'gh', 'gi',
                      'gm', 'gov', 'gs', 'gu', 'gy', 'hm', 'in', 'info', 'int', 'io', 'jm', 'ki', 'kn',
                      'ky', 'lc', 'lk', 'lr', 'ls', 'mh', 'mil', 'mp', 'ms', 'mu', 'nato', 'name', 'nf', 
                      'nom', 'nr', 'nu', 'nz', 'pn', 'pw', 'sb', 'sc', 'sh', 'sl', 'store', 'sz', 'tc', 'tk', 'to',
                      'tt', 'tv', 'tz', 'ug', 'um', 'vc', 'vg', 'vi', 'vu', 'web', 'ws', 'zm', 'zw', 'ai', 'arpa',
                      'as', 'cc', 'firm', 'nt', 'na', 'aero', 'biz', 'coop', 'mobi', 'museum', 'travel', 'eu', 'gg',
                      'im', 'je', 'pro'],
            afrikaans: ['za'], albanian: ['sg'],
            arabic: ['eg', 'ad', 'bh', 'dz', 'eh', 'er', 'iq', 'jo', 'km', 'kw', 'lb', 'ly', 'ma', 'om', 'qa',
                     'sa', 'sd', 'so', 'sy', 'td', 'tn', 'ye', 'ae', 'mr', 'ps'],
            armenian: ['am'], azerbaijaniturkic: ['az'], belarusian: ['by'], bengali: ['bd'], bulgarian: ['bg'], burmese: ['mm'],
            catalan: ['cat', 'ad'], chichewa: ['mw'], chineses: ['cn', 'hk', 'mo'], chineset: ['tw'],
            croatian: ['hr'], czech: ['cz', 'cs'], danish: ['dk', 'fo', 'gl'],
            dutch: ['nl', 'an', 'be', 'sr', 'aw'], dzongkha: ['bt'], estonian: ['ee'], filipono: ['ph'], finnish: ['fi'],
            french: ['fr', 'bf', 'bi', 'bj', 'cf', 'cg', 'cd', 'ci', 'dj', 'fx', 'ga', 'gf', 'gn', 'gp', 'ht',
                     'la', 'lu', 'mc', 'mg', 'ml', 'mq', 'nc', 'ne', 'pf', 'pm', 're', 'rw', 'sn', 'tf', 'tg',
                     'wf', 'yt', 'zr', 'cm'],
            german: ['de', 'at', 'ch', 'li'], greek: ['gr', 'al', 'cy'], hausa: ['ng'], hebrew: ['il'], hindi: ['in'],
            hungarian: ['hu'], iceland: ['is'], indonesian: ['id'], irish: ['ie'], italian: ['it', 'sm', 'va'], japanese: ['jp'],
            khmer: ['kh'], korean: ['kr', 'kp'], latvian: ['lt'], lithuanian: ['lv'], macedonian: ['mk'],
            malay: ['my'], maldivian: ['mv'], maltese: ['mt'], mongolian: ['mn'], nepali: ['np'], norwegian: ['no', 'sj'],
            papuan: ['pg'], pashto: ['af'], persian: ['ir'], polish: ['pl'],
            portuguese: ['pt', 'ao', 'cv', 'gw', 'st', 'tp', 'mz', 'tl'],
            portugueseb: ['br'], romanian: ['ro', 'md'],
            russian: ['ru', 'am', 'kg', 'kz', 'mn', 'su', 'tm', 'ua', 'uz'],
            serbian: ['yu', 'me', 'rs'], serbocroatian: ['ba'], serbocroatianz: ['hr'], serbocroatianb: ['yu'], slovak: ['sk'], slovenian: ['si'], somali: ['so'],
            spanish: ['es', 'ar', 'bo', 'cl', 'co', 'cr', 'cu', 'do', 'ec', 'gq', 'gt', 'hn', 'mx', 'ni', 'pa',
                      'pe', 'pr', 'py', 'sv', 'uy', 've'],
            swahili: ['ke'], swedish: ['se', 'ax'], tajik: ['tj'], thai: ['th'], turkish: ['tr'], turkmen: ['tm'], urdu: ['pk'],
            ukrainian: ['ua'], uzbek: ['uz'], vietnamese: ['vn'], uninhabited: ['bv']
    };

    //private properties
    var gSessionId = null;
    //'defines'
    const VERSION = "2.7.2";
    const IS_DEBUG_MODE = true;
    
    //public functions
    pub.init = function() {
        if (navigator.userAgent.indexOf("Firefox")!=-1)
            pub.isFF = true;
        else
            pub.isFF = false;
    };

    pub.debug = function(msg, isFull) {
        if (!IS_DEBUG_MODE)
            return;
        var date = new Date();
        var timeStr = date.getMinutes() + ":" + date.getSeconds() + ":" + date.getMilliseconds();
        var prefix = "Foxlingo (" + timeStr + ") ";
        try {
            a.b = b.c;
        } catch (e) {
            if (isFull) {
                dump(prefix + ": " + e.stack + "\n");
                return;
            }
            var s = "chrome://foxlingo/content/";
            var index = e.stack.indexOf(s);
            index = e.stack.indexOf(s, index+1);
            var index2 = e.stack.indexOf("\n", index+1);
            var lineNumber = e.stack.substring(index+s.length, index2);
            dump(prefix + lineNumber + ": " + msg + "\n");
            // output to error console
            window.setTimeout(function() { throw new Error("[debug] " + prefix + lineNumber + ": " + msg); }, 0);
        }
    };

    pub.debugException = function(e) {
        pub.debug("An exception occurred. Error name: " + e.name + ". Error message: " + e.message, true);
    };

    pub.getSession = function() {
        var mainWindow = pub.mainWindow();
        if (!mainWindow.FoxlingoSession)
            mainWindow.FoxlingoSession = {};
        return mainWindow.FoxlingoSession;
    };

    pub.getCurrentDocument = function() {
        if (!Foxlingo.getTabBrowser())
            return null;
        return Foxlingo.getTabBrowser().selectedBrowser.contentWindow.document;
    };
        
    pub.getTabByUrl = function(urlToFind) {
        for (var i = 0; i<Foxlingo.getTabBrowser().browsers.length; i++) {
            var window = Foxlingo.getTabBrowser().browsers[i].contentWindow;
            if (window && window.document && window.document.URL && window.document.URL==urlToFind) 
                return window.document;
        }
        return null;
    };
    
    pub.openTabL = function(url) {
        var openlPref = Foxlingo.Prefs.getCharPref("openl");
        if (openlPref=="openCurrentL" || pub.getUrl()=="about:blank" || url==pub.getUrl())
            pub.openURL(url,"currenttab");
        else if (openlPref=="openTabL")
            pub.openURL(url,"newtab");
        else if (openlPref=="openWindowL")
            pub.openURL(url,"newwindow");
    };
    
    pub.getDomain = function(type, optDomain, target, onlyLabel) {
        var url = pub.getUrl(null, target);

        var hostDomain = optDomain;
        var shortDomain;
        if (target || !optDomain) {
            if (!url || url.indexOf('about:')!=-1 || url.indexOf('file://')!=-1 || url.indexOf('chrome://')!=-1 ||
                (!onlyLabel && url.substr(0,6)=='ftp://'))
                return "disabled";
            if (Foxlingo.Translation.isUrlTranslated(target))
                return "back";
            
            var hostname;
            if (target) {
                hostname = target.location.hostname;    
            } else {
                target = pub.getCurrentDocument();
                hostname = pub.getCurrentDocument().location.hostname;
            }
            if (!target || !target.location || !target.location.hostname || target.URL.indexOf("about:")!=-1)
                return false;    
            
            hostDomain = hostname.substr(hostname.lastIndexOf('.')+1);
            
            if (hostname[2]=='.') {
                shortDomain = hostname.substr(0, 2);
                if (shortDomain!="eu") {
                    for (var language in Foxlingo.Languages) { //TODO: is this check necessary or is it enough to check the domains arrays below?
                        if (Foxlingo.Languages[language].shortName==shortDomain) {
                            if (type=="domain")
                                return Foxlingo.Languages[language].domain;
                            else
                                return language;
                        }
                    }
                }
            }
        }
        
        for (var lang in pub.domains) {
            if (shortDomain && pub.domains[lang].indexOf(shortDomain)!=-1)
                hostDomain = shortDomain;
            else if (pub.domains[lang].indexOf(hostDomain)==-1)
                continue;
            if (type=="domain")
                return hostDomain;
            else
                return lang;
        }
        
        return "unknowndomain";
    };

    pub.getUrl = function(coded, target) {
        if (!window.content || !pub.getCurrentDocument())
            return false;
        
        var url;
        if (!target)
            url = pub.getCurrentDocument().URL;
        else
            url = target.URL;
        
        if (!url)
            url = '';

        if (coded=="coded") { 
            var url = encodeURIComponent(url);
        } else if (coded!="dontChangeCoding") {
            var url = decodeURIComponent(url);
        }
        return url;
    };
    
    pub.openTabT = function(url) {
        openTabImpl(url, 't');
    };
    
    pub.openTabS = function(url) {
        openTabImpl(url, 's');
    };
    
    pub.openURL = function(url, type){
        switch (type) {
            case "currenttab": window.content.document.location.href = url; break;
            case "newtab": getBrowser().selectedTab = getBrowser().addTab(url); break;
            case "newwindow": window.open(url); break;
            case "fromDialog":
                var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
                var win = wm.getMostRecentWindow("navigator:browser");
                var gBrowser = win.getBrowser();
                gBrowser.selectedTab = getBrowser().addTab(url); break;
            default: break;
        }
    };
    
    pub.splitTerms = function(searchwords) {
        var string = pub.trimString(searchwords);
        var buffer = "";
        var inQuotes = false;
        var inWord = false;
        var myArray = [];
        for (var i = 0; i < string.length; i++) {
            var c = string.charAt(i);
            switch (c) {
                case ' ':
                    if (!inQuotes) {
                        myArray.push(buffer);
                        buffer = "";
                        if (inWord)
                            inWord = false;
                    } else {
                        buffer += c;
                    }
                    break;
                case '"':
                    inQuotes = !inQuotes;
                    inWord = !inQuotes;
                    break;
                case '+':
                case '~':
                    //fallthrough
                default:
                    if (!inWord)
                        inWord = true;
                    buffer += c;
                    break;
            }
        }

        if (buffer)
            myArray.push(buffer);
        return myArray;
    };
    
    pub.trimString = function(string) {
        if (!string)
            return "";

        return string.replace(/^\s+/, '').replace(/\s+$/, '').replace(/\s+/g, ' '); 
    };
    
    pub.convertTermsToURI = function(terms) {
        return terms.replace(/ /g, '+');
    };
    
    pub.getTarget = function() {
        if (Foxlingo.Prefs.getCharPref("openl")=="openWindowL")
            return "_blank";
        return "_content";
    };
    
    pub.getClientIp = function() {
        Foxlingo.Locale.geobytesXMLHttp.onreadystatechange = gotClientIp;
        Foxlingo.Locale.geobytesXMLHttp.open("GET", "http://www.foxlingo.com/getclientip/index.html", true);
        Foxlingo.Locale.geobytesXMLHttp.send(null);
    };
    
    pub.getIsFromMozilla = function() {
        var isFromMozilla = true;
        var prefs = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("foxlingo.");
	var prefType = prefs.getPrefType('isfrommozilla');
        if (prefType != prefs.PREF_INVALID)
            isFromMozilla =  prefs.getBoolPref('isfrommozilla');
        else {
            //Are we coming from mozilla?
            var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"]
                        .getService(Components.interfaces.nsICookieManager);
            var cookieIterator = cookieManager.enumerator;
            while (cookieIterator.hasMoreElements()){
                var cookie = cookieIterator.getNext();
                if (cookie instanceof Components.interfaces.nsICookie){
                    if (cookie.host && cookie.host.indexOf("foxlingo.com") >= 0  && cookie.name == "FoxLingoS")
                        isFromMozilla = false;
                }
            }
            prefs.setBoolPref('isfrommozilla',isFromMozilla);
        }
        return isFromMozilla;
    }
    
    pub.removeChildren = function(menu) {
        if (!menu)
            return;
        
        for (var i = menu.childNodes.length - 1; i >= 0; i--)
            menu.removeChild(menu.childNodes[i]);
    };
    
    pub.openError = function(error, dynamictext) {
        
        if (dynamictext)
            msg += dynamictext;
        
        Foxlingo.Status.showStatusMessage(msg, true);
    };
    
    pub.openMessage = function(error) {
        pub.openTabT("http://www.foxlingo.com/showtext/index.html?text=" + document.getElementById("foxlingo-stringbundle").getString("foxlingo.text." + error));
    };
        
    pub.isBrowserWindow = function() {
        try {
            if (window && gBrowser)
                return gBrowser;
        } catch(e){ }
    };
    
    pub.getSecondFlag = function(language) {
        if (((language=="english") && (Foxlingo.Prefs.getCharPref("engflag")=="ukflag")) ||
            ((language=="french") && (Foxlingo.Prefs.getCharPref("freflag")=="caflag")) ||
            ((language=="spanish") && (Foxlingo.Prefs.getCharPref("spaflag")=="meflag")))
            return "2.png";
        else
            return ".png";
    };
    
    pub.changeLanguage = function(language, type) {
        if (type=="long") {
            for (var lang in Foxlingo.Languages) {
                if (Foxlingo.Languages[lang].shortName==language)
                    return lang;
            }
            return '';
        } 
          
        try {
            if (type=="shortName")
                return Foxlingo.Languages[language].shortName;
            else
                return Foxlingo.Languages[language].domain;
        } catch(e){
            pub.debugException(e);
        }
        return '';
    };
    
    pub.stripJunkText = function(textTarget) {
        var regExp = /<\/?[^>]+>/gi;
        
        var textToStrip = textTarget;
        //textToStrip = textToStrip.replace(/\=|\?|\&|_|\)|;|'|"/gi, ' ');
        textToStrip = textToStrip.replace(/^\s+/, ''); 
            textToStrip = textToStrip.replace(/\s+$/, ''); 
            textToStrip = textToStrip.replace(/&nbsp;/g, ' ');
            textToStrip = textToStrip.replace(/\s+/g, ' ');     
        return textToStrip;
    };
    
    pub.urlDecodeSpaces = function(txt, isIncludePlus) {
        txt = txt.replace(/%20/g, ' ').replace(/%2B/g, ' ');
        if (isIncludePlus)
            txt = txt.replace(/\+/g, ' ');
        return txt;
    };

    pub.openInNewTab = function(url) {
        getBrowser().selectedTab = getBrowser().addTab(url);
    };

    pub.mainWindow = function() {
        var mainWindow = window;
        while (mainWindow.opener && mainWindow.opener.window)
            mainWindow = mainWindow.opener.window;
        return mainWindow;
    };

    pub.getVersion = function() {
        if (!pub.isFF)
            return VERSION;
	try {
	     var extensionManager = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);  
             var addon = extensionManager.getItemForID("{ef62e1ce-d2a4-4cdd-b7ec-92b120366b66}");  
             return addon.version; 	
	} catch (e) {}
	return VERSION; 
    };

    pub.openProofreader = function(isSeaMonkey) {
            var browserString = '';
            if (isSeaMonkey)
            	browserString = "sm";
            var searchBox = document.getElementById("foxlingo-search-box");
            if (searchBox && searchBox.value)
                var query = searchBox.value;
            else {
                var query = content.window.getSelection().toString();
                query = Foxlingo.Utils.stripJunkText(query);
            }
            query = encodeURIComponent(query);
            pub.openTabL("http://www.foxlingo.com/partners/whitesmoke/?s=2&p=1&v=" + browserString + "2.7.2&q=" + query);
    };

    pub.openDictionary = function(clickEvent, isContextMenu) {
            var babylonLanguage =  Foxlingo.Utils.changeLanguage(Foxlingo.Prefs.getCharPref("options-dlang"), "shortName");
            switch (babylonLanguage) {
                case "en": 
                case "fr": 
                case "it": 
                case "es": 
                case "nl": 
                case "pt": 
                case "de": 
                case "ru": 
                case "ja": 
                case "el": 
                case "ko": 
                case "he": 
                case "ar": 
                case "th": 
                case "hu": 
                case "lt": 
                case "lv": 
                case "ca": 
                case "sk": 
                case "ur": 
                case "sl": 
                case "et": 
                case "da": 
                case "fi": 
                case "no": 
                case "ro": 
                case "sv": 
                case "uk": 
                case "eu": 
                case "mk": 
                case "af": 
                case "la": 
                case "eo": 
                case "hi": 
                case "so": 
                case "ha": 
                   break;
                case "cn": babylonLanguage = "zhs";
                    break;
                case "tw": babylonLanguage = "zht";
                    break;
                case "tu": babylonLanguage = "tr";
                    break;
                case "po": babylonLanguage = "pl";
                    break;
                case "cz": babylonLanguage = "csl";
                    break;
                case "cr": babylonLanguage = "hr";
                    break;
                case "se": babylonLanguage = "sr";
                    break;
                case "bu": babylonLanguage = "bg";
                    break;
                case "ic": babylonLanguage = "is";
                    break;
                case "pe": babylonLanguage = "fa";
                    break;
                case "in": babylonLanguage = "id";
                    break;
                default: babylonLanguage = "en";
                    break;
            }
            var searchBox = document.getElementById("foxlingo-search-box");
            var query = "";
            if (searchBox && searchBox.value && !isContextMenu) {
                query = searchBox.value;
            } else if (content && content.window && content.window.getSelection() && content.window.getSelection().toString().length>0) {
                var query = content.window.getSelection().toString();
                query = Foxlingo.Utils.stripJunkText(query);
            } else if (isContextMenu && document.getElementById("Foxlingo_context-dictionary-item") && document.getElementById("Foxlingo_context-dictionary-item").word) {
                var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
                var win = wm.getMostRecentWindow("navigator:browser");
                query = win.document.getElementById("Foxlingo_context-dictionary-item").word;
            } else if (gContextMenu && gContextMenu.target && gContextMenu.target.textContent) {
                query = gContextMenu.target.textContent;
            }
            var url = "http://www.foxlingo.com/dictionary/?q=" + encodeURIComponent(query) + "&to=" + babylonLanguage;
            if (isContextMenu)
                window.setTimeout(function() { Foxlingo.Utils.openFoxLingoPopup(clickEvent, url + "&f=1", true); }, 0);
            else
                pub.openTabL(url);
    };
    
    pub.setCurrencyAccordingToCountry = function() {
        Foxlingo.Utils.debug("changing currentcy according to country");
        var countryToCurrency = {
            "au":"aud","pt":"brl","br":"brl","ca":"cad",
            "cn":"cny","ch":"chf","jp":"jpy","il":"ils",
            "us":"usd","gb":"gbp"
        }
        var country = Foxlingo.Prefs.getCharPref("foundipcountry");
        if (!country || country == "" || !countryToCurrency[country.toLowerCase()])
            return;
        country = country.toLowerCase();
        Foxlingo.Prefs.setCharPref("options-currency",countryToCurrency[country]);
        Foxlingo.Prefs.setCharPref("tempcurrency",countryToCurrency[country]);
        Foxlingo.Utils.debug("changed to: " + countryToCurrency[country]);
    }

    pub.openFoxLingoPopup = function(event, url, isDictionary) {
        var foxlingoPopupIframe = document.getElementById('foxlingoPopupIframe');
        if (foxlingoPopupIframe)
            foxlingoPopupIframe.setAttribute("hidden", "true");
        var foxlingoPopup = document.getElementById('foxlingoPopup');
        if (!foxlingoPopup)
            return;
        if (isDictionary)
            foxlingoPopup.setAttribute("style", "width: 450px; height: 400px;"); 
        else
            foxlingoPopup.setAttribute("style", "width: 745px; height: 400px;");
        var popupPositionY = event.clientY;
        if (window.screenY-400>popupPositionY)
            popupPositionY = window.screenY-400;
        foxlingoPopup.openPopup(null, "", event.clientX, popupPositionY, false, false);
        if (foxlingoPopupIframe) {
            foxlingoPopupIframe.setAttribute("src", url);
            window.setTimeout(function() { var foxlingoPopupIframe = document.getElementById('foxlingoPopupIframe');
                                           if (foxlingoPopupIframe)
                                               foxlingoPopupIframe.setAttribute("hidden", "false"); }, 1500);
        }
    };

    pub.parseWord = function(string, offset) {
	var start = offset;
	var end = offset + 1;
	var validChars = /[^\s,-;:_#~=()/&%!<>{}\$\*\+\\\|\^\.\?\[\]""]/m;
	if (!validChars.test(string.substring(start, start + 1)))
	    return;
	while (start > 0) {
	    if (!validChars.test(string.substring(start - 1, start)))
		break;
            start--;
	}
	while (end < string.length) {
	    if (!validChars.test(string.substring(end, end + 1)))
		break;
	    end++;
	}
	return string.substring(start, end);
    };
    
    pub.isWebUrl = function(url) {
        url = decodeURIComponent(url);
        if (!url || url.match(/^(http:\/\/localhost\/)/) || url.match(/^(about:)/) || url.match(/^(file:)/) || url.match(/^(chrome:)/) || url.match(/^(javascript:)/) || url=="unknown")
            return false;
        return true;
    };
    
    pub.toggleToolbarButton = function(button) {
        var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
        var enumerator = windowMediator.getEnumerator("");
        while(enumerator.hasMoreElements()) {
            var win = enumerator.getNext();
            var toolbarbutton = win.document.getElementById("foxlingo-toolbar-" + button);
            if (toolbarbutton)
                toolbarbutton.collapsed = !toolbarbutton.collapsed;
        }
    };

    pub.getSiteLanguage = function(referer) {
	try {
	    if (!Foxlingo.Prefs.getBoolPref("identifysitelanguage"))
	        return;
            var siteLanguage = "unknown";
            var url = pub.getUrl("coded");
            if (!pub.isWebUrl(url))
                return siteLanguage;
            if (Foxlingo.session && Foxlingo.session.cache && Foxlingo.session.cache["tabSelected"]=="true" && Foxlingo.session.cache[url]) {
                Foxlingo.session.cache["tabSelected"] = "false";
                siteLanguage = Foxlingo.session.cache[url];
                window.setTimeout(function() { pub.setToolbarButtonSiteLangauge(siteLanguage); }, 10);
                return siteLanguage;
            }
            var isReferer = 0;
            if (referer)
                isReferer = 1;
            else
                referer = "";
            var strbundle = document.getElementById("foxlingo-stringbundle");
            var xmlHttp = new XMLHttpRequest();
            xmlHttp.onreadystatechange = function() {
                if (xmlHttp.readyState==4) {
                    siteLanguage = xmlHttp.responseText.toLowerCase();
                    Foxlingo.session.cache[url] = siteLanguage;
                    Foxlingo.session.cache["lastUrl"] = url;
                    Foxlingo.Utils.setToolbarButtonSiteLangauge(siteLanguage);
                    return siteLanguage;
                }
            };
            xmlHttp.open("GET", "http://lang.similargroup.com/?id=" + pub.getGSessionId() + isReferer + "&url=" + url, true);
            xmlHttp.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
            xmlHttp.setRequestHeader('Referer', referer);
            xmlHttp.send(null);
	} catch (e) { }
    };     

    pub.setToolbarButtonSiteLangauge = function(siteLanguage) {
//        if (Foxlingo.Prefs.getBoolPref("autotransWorldlingo"))
//            Foxlingo.Toolbar.changeDomainButton();
        var backanddomain = document.getElementById("Foxlingo_backanddomain-item");
        var strbundle = document.getElementById("foxlingo-stringbundle");
        var tooltiptext = backanddomain.getAttribute("tooltiptext");
        var siteLanguageLabel = strbundle.getString("foxlingo.language." + siteLanguage);
        var siteLanguageTextLabel = strbundle.getString("foxlingo.text.siteLanguage");
        if (tooltiptext.match(siteLanguageTextLabel) || backanddomain.getAttribute("label").match(strbundle.getString("foxlingo.text.original")))
            return;
        if (!siteLanguage || siteLanguage=="undefined")
            siteLanguage = "unknown";
        backanddomain.setAttribute("tooltiptext", tooltiptext + "\n" + siteLanguageTextLabel + ": " + siteLanguageLabel);
        var currentImage = backanddomain.getAttribute("image");
        if ((siteLanguage=="unknown")
          || (siteLanguage=="english" && currentImage.indexOf("uk.png")!=-1)
          || (siteLanguage=="english" && (currentImage.indexOf("com.png")!=-1 || currentImage.indexOf("net.png")!=-1 || currentImage.indexOf("org.png")!=-1 || currentImage.indexOf("gov.png")!=-1 || currentImage.indexOf("edu.png")!=-1)))
            return;
        backanddomain.setAttribute("image", "chrome://foxlingo/skin/flags-s/" + siteLanguage + ".png");
    }

    pub.getGSessionId = function() {
        if (!this.gSessionId) {
            this.gSessionId = Foxlingo.Prefs.getCharPref("gSessionId");
            if (!this.gSessionId) {
                this.gSessionId = (pub.S4()+pub.S4()+"-"+pub.S4()+"-"+pub.S4()+"-"+pub.S4()+"-"+pub.S4()+pub.S4()+pub.S4());
                Foxlingo.Prefs.setCharPref("gSessionId", this.gSessionId);
            }
        }
        return this.gSessionId;
    }

    pub.S4 = function() {
        return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
    }

    pub.insertWorldLingoAds = function(event) {
        if (!event.originalTarget.location || !event.originalTarget instanceof HTMLDocument)
            return;
        if (!event.originalTarget.location.toString().match(/http:\/\/www\.worldlingo\.com\/S1790\.5\/translation.*/))
            return;
        var worldlingoTopElement = event.originalTarget.getElementsByTagName("html")[0];
        var worldlingoAdBackground = event.originalTarget.createElement('div');
        worldlingoAdBackground.setAttribute("style", "position: relative; z-index: 1; background: white; width: 100%; height: 95px; border-bottom: gray 1px solid;");
        worldlingoTopElement.insertBefore(worldlingoAdBackground, worldlingoTopElement.firstChild);
        var worldlingoText = event.originalTarget.createElement('div');
        worldlingoText.innerHTML = "Transaltion Powered by WorldLingo";
        worldlingoText.setAttribute("style", "font-size: 12px; float: right;");
        worldlingoAdBackground.appendChild(worldlingoText);
        var worldlingoAd = event.originalTarget.createElement('iframe');
        worldlingoAd.setAttribute("src", "http://www.foxlingo.com/ads/?t=banner");
        worldlingoAd.setAttribute("style", "float: left; border: none; left: 0px; padding: -5px 0px 0px 0px; margin: -5px 0px 0px 0px;");
        worldlingoAd.setAttribute("width", "760;");
        worldlingoAd.setAttribute("height", "110;");
        worldlingoAdBackground.appendChild(worldlingoAd);
    };

    pub.openUrlFromDialog = function(url, referer) {
        var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
        var win = wm.getMostRecentWindow("navigator:browser");
        var gBrowser = win.getBrowser();
        gBrowser.selectedTab = gBrowser.addTab(url, referer);
    }

    pub.getStatsReferer = function() {
        var defaultSearchEngine = "5";
        if (Foxlingo.Prefs.getCharPref("defaultsearchengine")=="zugoBing")
            defaultSearchEngine = "0";
        else if (Foxlingo.Prefs.getCharPref("defaultsearchengine")=="zugoAsk")
            defaultSearchEngine = "1";
        else if (Foxlingo.Prefs.getCharPref("defaultsearchengine")=="ixquick")
            defaultSearchEngine = "2";
        else if (Foxlingo.Prefs.getCharPref("defaultsearchengine")=="yahooAsk")
            defaultSearchEngine = "3";
        else if (Foxlingo.Prefs.getCharPref("defaultsearchengine")=="zugoYahoo")
            defaultSearchEngine = "4";
        var amountOfChars = 0;
        var source = "0";
        try {
            if (Foxlingo.Prefs.TEMPINST.getCharPref("source"));
                source = Foxlingo.Prefs.TEMPINST.getCharPref("source");
        } catch(e) {}
        var hash = "0004"
                 + "00" + "04" + Foxlingo.Utils.leftPad(Foxlingo.Utils.getVersion().toString().replace(/\./gi, ""), 4)
                 + "01" + "20" + Foxlingo.Utils.getGSessionId().replace(/-/gi, "")
                 + "02" + "01" + defaultSearchEngine
                 + "03" + "01" + source + "e";
                 
        amountOfChars = Foxlingo.Utils.leftPad(Foxlingo.Utils.convertNumbers(hash.length + 6, "10", "16"), 4);
        hash = "f1" + amountOfChars + hash;
        var ioService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
        return ioService.newURI("http://www.foxlingo.com/?h=" + hash, null, null);
    }

    pub.openAfterDownloadPage = function() {
        var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
        var browserWindow = windowMediator.getMostRecentWindow("navigator:browser");
        var source = ''; 
        try {
        if (Foxlingo.Prefs.TEMPINST.getCharPref('source')) 
             source = '?s=' + Foxlingo.Prefs.TEMPINST.getCharPref('source');
        } catch(e) {}
        browserWindow.setTimeout("Foxlingo.Utils.openUrlFromDialog('http://www.foxlingo.com/help/" + source + "', Foxlingo.Utils.getStatsReferer());", 1500);
    }

    pub.convertNumbers = function(input, origin, dest) {
        var convertBase = "0123456789abcdefghijklmnopqrstuvwxyz";
        input = input.toString().toLowerCase();
        origin = origin.toString();
        dest = dest.toString();
        var b = 0;
        var result = "";
        if (Number(origin)>convertBase.length || Number(dest)>convertBase.length || Number(origin)<2 || Number(dest)<2) 
            AddonFoxUtils.debug("Invalid numbering system");
        for (var c = 1; c<=input.length; c++) { 
            b += convertBase.indexOf(input.substring(c-1,c))*(Math.pow(origin,input.length-c)); 
            if (convertBase.indexOf(input.substring(c-1,c)) > Number(origin)) 
                AddonFoxUtils.debug('Character "'+input.substring(c-1,c)+'" not present in origin system');
        }
        var a = Math.floor(Math.log(b)/Math.log(dest));
        while (a>-1) {
            var e = Math.pow(dest,a)
            a--;
            var d = (b-b%e)/e+1;
            b%=e;
            var ciffer = convertBase.substring(d-1,d);
            result += ciffer;
        }
        return result
    }

    pub.leftPad = function(number, digitLength) {
        number = number.toString(); 
        var pad = ""; 
        if (digitLength > number.length) { 
            for (var characterCounter = 0; characterCounter < (digitLength - number.length); characterCounter++) { 
                pad += "0"; 
            } 
        } 
        return pad + number.toString(); 
    }

    //private functions
    function openTabImpl(url, suffix) {
        var capitalSuffix = suffix.toUpperCase();
        if ((Foxlingo.Prefs.getCharPref("open"+suffix)==("openCurrent"+capitalSuffix)) || (pub.getUrl()=="about:blank") ||
            (url==pub.getUrl()))
            pub.openURL(url,"currenttab");
        else if (Foxlingo.Prefs.getCharPref("open"+suffix)==("openTab"+capitalSuffix))
            pub.openURL(url,"newtab");
        else if (Foxlingo.Prefs.getCharPref("open"+suffix)==("openWindow"+capitalSuffix))
            pub.openURL(url,"newwindow");
    }
    
     function gotClientIp() {
        if (Foxlingo.Locale.geobytesXMLHttp.readyState==4 || Foxlingo.Locale.geobytesXMLHttp.readyState=="complete") { 
            var xmlHttpResponseText = Foxlingo.Locale.geobytesXMLHttp.responseText;
            if (xmlHttpResponseText) {
                Foxlingo.Prefs.setCharPref("clientipaddress", xmlHttpResponseText);
                Foxlingo.Locale.getLocaleFromI2L(xmlHttpResponseText);            
            }
        }
    }
    
    return pub;
}();
