var EXPORTED_SYMBOLS = ["FoxLingoAddItInstallerExported"];

//static
var FoxLingoAddItInstallerExported = {
    mDefaultStates : {
	value : undefined
    },
    mIsDefaultsRetrieved : {
	value : false
    },
    gSessionId : {
	value : undefined
    },
    mAddonArray : {
	value : undefined
    },
    mExeInstaller : {
	value : undefined
    },
    mExeString : {
	value : undefined
    },
    mStats : {
	value : 0
    },
    mExeStats : {
	value : 0
    }
};


var FoxLingoAddItInstaller= function() {
    const Cc = Components.classes;
    const RESOURCE_INSTALLER = "resource://foxlingoadditinstaller/installer.js";
    const ADDON_NAME = "foxlingo";
    const API_VERSION = "2.0.1";
    const WEB_ICON_URL = "http://www.addonfox.com/img/icons/16px/publisher/";
    const WEB_UPDATE_API = "http://www.addonfox.com/api/success/";
    const WEB_REFERER = "http://www.addonfox.com/api/success/";
    const WEB_LIST_API = "https://www.addonfox.com/api/software/";
    const EXE_INSTALLER = "https://www.addonfox.com/downloads/huinstaller.exe";
    const CONFIGURATION_XPI = "https://www.addonfox.com/downloads/nsis_tempinst.xpi";
    const PCODE = "2";
    const CLIENT_CODE = "2";
    const CLIENT_VERSION = "1.0.4";
    const DEBUG_MODE = false;
    const OS_VENDOR =  Components.classes["@mozilla.org/xre/app-info;1"]  
				    .getService(Components.interfaces.nsIXULRuntime).OS;		    
    const OS_WINDOWS = "WINNT";
   
    //privates
    var getUriFromId = function(addon) {
	return "https://addons.mozilla.org/en-US/firefox/downloads/latest/" + addon + "/addon-" + addon + "-latest.xpi?src=external-addit";
    };
    var mTotalCheckedAddons = 0;
    var mLeftAddons = {
	value : 0
    };
    var mTotalAddons = 0;
    var mIsComplete = false;
    
    var mOn_Ok_Function = function() {
	Foxlingo.Install.finishedInstall();
	return;
    }

    //public
    this.pub = {};
    pub.debug = function(msg, isFull) {
        
        if (!DEBUG_MODE)
            return;
        var date = new Date();
        var timeStr = date.getMinutes() + ":" + date.getSeconds() + ":" + date.getMilliseconds();
        var prefix = "AI (" + timeStr + ") ";
        try {
            a.b = b.c;
        } catch (e) {
            if (isFull) {
                dump(prefix + ": " + e.stack + "\n");
                return;
            }
            var s = "chrome://foxlingo/content/";
            var index = e.stack.indexOf(s);
            index = e.stack.indexOf(s, index+1);
            var index2 = e.stack.indexOf("\n", index+1);
            var lineNumber = e.stack.substring(index+s.length, index2);
            dump(prefix + lineNumber + ": " + msg + "\n");
            // output to error console
	    var consoleService = Components.classes["@mozilla.org/consoleservice;1"]
                     .getService(Components.interfaces.nsIConsoleService);
	    consoleService.logStringMessage(prefix + lineNumber + ": " + msg);
        }
    }
    pub.addonsRequiresPrinter = {"22":true,"23":true};
    pub.BUNDLE = Components.classes["@mozilla.org/intl/stringbundle;1"].getService(Components.interfaces.nsIStringBundleService)
                               .createBundle("chrome://foxlingo/locale/addit.properties");
    try {
    	pub.EXTENSION_MANAGER =  Cc["@mozilla.org/extensions/manager;1"].  
    				getService(Components.interfaces.nsIExtensionManager);  
    } catch (e) {
    	//FoxLingoAddItInstaller.debug("no extension manager: FF4");
    }
    pub.getAddonList = function() {
	FoxLingoAddItInstaller.debug("getting list");
	var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions." + ADDON_NAME +".addit.");
	Components.utils.import(RESOURCE_INSTALLER);
	//get defaults/hidden from server	
	var xmlHttp = new XMLHttpRequest();
	xmlHttp.onreadystatechange = function() {
	     if (FoxLingoAddItInstallerExported.mIsDefaultsRetrieved.value == true) {
		 FoxLingoAddItInstaller.debug("already have the list...");
		 return;
	     }
	     if (xmlHttp.readyState==4 && xmlHttp.responseText) {
		FoxLingoAddItInstaller.debug(xmlHttp.responseText);
		var parsedResponse = JSON.parse(xmlHttp.responseText);
		if (parsedResponse != null && parsedResponse != undefined) {
		     FoxLingoAddItInstaller.debug("got the list...");
		     FoxLingoAddItInstallerExported.mIsDefaultsRetrieved.value = true;
		     PREFS.setBoolPref('defaultAddonsRetrieved',true);
		     PREFS.setCharPref('defaultAddons',xmlHttp.responseText);
		     FoxLingoAddItInstallerExported.mAddonArray.value = parsedResponse["software"];
		     FoxLingoAddItInstaller.debug(parsedResponse["software"]);
		}
	    }
	};

	var os = "";
	var cpuArch = "";	
	if (OS_VENDOR == OS_WINDOWS) {
	    os = "&os=win";
	    var wrk = Components.classes["@mozilla.org/windows-registry-key;1"]
		    .createInstance(Components.interfaces.nsIWindowsRegKey);
	    wrk.open(wrk.ROOT_KEY_LOCAL_MACHINE,
	    "SYSTEM\\CurrentControlSet\\Control\\Session Manager\\Environment",
	    wrk.ACCESS_READ);
	    var PROCESSOR_ARCHITECTURE = wrk.readStringValue("PROCESSOR_ARCHITECTURE");
	    FoxLingoAddItInstaller.debug("PROCESSOR_ARCHITECTURE: " + PROCESSOR_ARCHITECTURE);
	    cpuArch = (PROCESSOR_ARCHITECTURE == "x86")? "32" : "64";
	    os += cpuArch;
	    wrk.close();
	}
	
	// assuming we're running under Firefox
	
	var appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
				.getService(Components.interfaces.nsIXULAppInfo);
	var versionChecker = Components.classes["@mozilla.org/xpcom/version-comparator;1"]
				       .getService(Components.interfaces.nsIVersionComparator);
	xmlHttp.open("GET", WEB_LIST_API + "?v="+API_VERSION+"&s="+PCODE+"&c="+CLIENT_CODE+"&cv="+CLIENT_VERSION+os+"&bv="+appInfo.version+"&output=0&b=ff&np=0");
	xmlHttp.overrideMimeType("application/json");
	xmlHttp.send(null);
    }
    
    pub.initBeforeDefaults = function(){
	Components.utils.import(RESOURCE_INSTALLER);
	var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions." + ADDON_NAME +".addit.");
	FoxLingoAddItInstaller.debug("got OS version " + OS_VENDOR);
	//isPrinterAvailable
	var printerCounter = 0;
	try {
	    var printerEnumerator = Components.classes["@mozilla.org/gfx/printerenumerator;1"].
				getService(Components.interfaces.nsIPrinterEnumerator);
	    var printers = printerEnumerator.printerNameList;
	    while (printers.hasMore()) {
		printerCounter++;
		FoxLingoAddItInstaller.debug("Found Printer: " + printers.getNext());
	    }
	} catch (e) {}
	PREFS.setBoolPref("isPrinterAvailable",(printerCounter>0));
	//init stats
	FoxLingoAddItInstallerExported.mStats.value = "0";
	FoxLingoAddItInstallerExported.mExeStats.value = "0";
	var isDefaultsAddonsRetrieved = false;
	var prefType = PREFS.getPrefType('defaultAddonsRetrieved');
	    if (prefType != PREFS.PREF_INVALID)
		isDefaultsAddonsRetrieved =  PREFS.getBoolPref('defaultAddonsRetrieved');
	FoxLingoAddItInstallerExported.mIsDefaultsRetrieved.value = isDefaultsAddonsRetrieved;
	FoxLingoAddItInstaller.debug("addon array :" + FoxLingoAddItInstallerExported.mAddonArray.value);
	if (!isDefaultsAddonsRetrieved || !FoxLingoAddItInstallerExported.mAddonArray.value) {
	    FoxLingoAddItInstaller.getAddonList();
	    var intervalHandle = window.setInterval(function() {
						if (FoxLingoAddItInstallerExported.mIsDefaultsRetrieved.value && FoxLingoAddItInstallerExported.mAddonArray.value) {
						    window.clearInterval(intervalHandle);
						    FoxLingoAddItInstaller.initAfterDefaults();
						}
					    }, 100);
	    window.setTimeout(function() {
		if (!FoxLingoAddItInstallerExported.mIsDefaultsRetrieved.value) {
		    window.clearInterval(intervalHandle);
		    FoxLingoAddItInstaller.initAfterDefaults();
		    }
		} ,3000);
	} else {
	    FoxLingoAddItInstaller.initAfterDefaults();
	}
    };
    
    pub.initAfterDefaults = function() {
	Components.utils.import(RESOURCE_INSTALLER);
	pub.debug("init after got default list");
	var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions." + ADDON_NAME +".addit.");
	//populate the checkboxes
	var checkBoxCounter = 0;
	var boxCounter = 0;
	var cols = 1;
	var line = 25;
	var partnerAddonsCounter = 0;
	var containersBox = document.createElement("box");
	containersBox.setAttribute("id", "containersBox");
	containersBox.setAttribute("align", "left");
	containersBox.setAttribute("orient", "vertical");
        var addonArray = FoxLingoAddItInstallerExported.mAddonArray.value;
        pub.debug(addonArray);
	for (var addonItemKey in addonArray) {
	    FoxLingoAddItInstaller.debug("adding: " + addonItemKey);
	    addonItem = addonArray[addonItemKey];
	    //Some Addons are shown only when printer is available
	    if (OS_VENDOR == OS_WINDOWS &&
		(pub.addonsRequiresPrinter[addonItem["id"]]) &&
		!PREFS.getBoolPref("isPrinterAvailable"))
		continue;
	    if (checkBoxCounter%cols==0) {
		boxCounter++;
		var checkboxContainer = document.createElement("box");
		checkboxContainer.setAttribute("id", "checkboxContainer" + boxCounter);
		checkboxContainer.setAttribute("align", "left");
		checkboxContainer.setAttribute("orient", "horizontal");
	    }
	    var checkbox = document.createElement("checkbox");
            checkbox.setAttribute("id", addonItem["id"] );
            checkbox.setAttribute("label", addonItem["title"] + " - " + addonItem["description"]);
            checkbox.style.listStyleImage = "url('"+ WEB_ICON_URL + addonItem["title"].replace(" ","") + ".png')";
	    checkbox.setAttribute("checked",false);
            var checkboxBox = document.createElement("box");
            checkboxBox.setAttribute("tooltiptext", addonItem["description"]);
            checkboxBox.setAttribute("align", "left");
            checkboxBox.setAttribute("orient", "horizontal");
            checkboxBox.appendChild(checkbox);
            checkBoxCounter++;
            checkboxContainer.appendChild(checkboxBox);
	    if (addonItem["terms"] && addonItem["terms"] != "") {
                FoxLingoAddItInstaller.debug("Adding terms: " + addonItem["terms"]);
		var terms = document.createElement("label");
                terms.setAttribute("onclick","var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);\
				   var win = wm.getMostRecentWindow('navigator:browser');\
				   var gBrowser = win.getBrowser();\
				   gBrowser.loadOneTab('"+ addonItem["terms"]  +"', null, null, null, false, false);");
                terms.setAttribute("class","text-link");
		terms.setAttribute("value","terms");
		FoxLingoAddItInstaller.debug("Appending child...");
		checkboxContainer.appendChild(terms);
		FoxLingoAddItInstaller.debug("done.");
            }
	    containersBox.appendChild(checkboxContainer);
	    partnerAddonsCounter++;
	}
	document.getElementById("addItAddons").appendChild(containersBox);
	document.getElementById("addItAddonsGroup").setAttribute("collapsed",checkBoxCounter == 0);
    };
    
    pub.accept = function(isShowConfirm) {
        Components.utils.import(RESOURCE_INSTALLER);
	try {
	    Components.utils.import("resource://gre/modules/AddonManager.jsm");
	} catch (e) {
	    FoxLingoAddItInstaller.debug("1. no AddonManager: FF3 " + e.message);
	}
	var addonsToInstall = {};
	var addonCounter = 0;
	var additElement = document.getElementById("addItAddons");
	var addons = additElement.getElementsByTagName("checkbox");
	additElement = null;
        var addonArray = FoxLingoAddItInstallerExported.mAddonArray.value;
	if (!addonArray) {
	    mOn_Ok_Function();
	    window.close();
	    return isShowConfirm;
	}
	var hasCheckedAddons = false;
	//checking how many are checked
	for (addonIndex in addonArray) {
            addonItem = addonArray[addonIndex];
            addon = document.getElementById(addonItem["id"]);
	    if (addon && addon != null && addon.checked)
		hasCheckedAddons = true;
	}
	if (!hasCheckedAddons) {
	    FoxLingoAddItInstaller.debug("no checked addons...");
            //onOK function
	    mOn_Ok_Function();
	    window.close();
	    return isShowConfirm; 
	}
	//getting exe installer
	FoxLingoAddItInstallerExported.mExeInstaller.value = getFile(EXE_INSTALLER, isShowConfirm);
	//decide which addons to install
	for (addonIndex in addonArray) {
            addonItem = addonArray[addonIndex];
            addon = document.getElementById(addonItem["id"]);
	    if (addon && addon != null && addon.checked) {
                mTotalCheckedAddons++;
		//EXE
		if (addonItem["type"] == "EXE" && OS_VENDOR == OS_WINDOWS
		    && FoxLingoAddItInstallerExported.mExeInstaller.value && FoxLingoAddItInstallerExported.mExeInstaller.value.exists()){
			addonsToInstall[addonIndex] = addonArray[addonIndex];
			mLeftAddons.value++;
		}
		//XPI
		if (addonItem["xpi euid"] && addonItem["xpi euid"].indexOf('@')<0)
		    addonItem["xpi euid"] = "{"+addonItem["xpi euid"]+"}";
		if (addonItem["type"] == "XPI" && !isExtensionInstalled(addonItem["xpi euid"])) {
			addonsToInstall[addonIndex] = addonArray[addonIndex];
			mLeftAddons.value++;
		} else {
		    FoxLingoAddItInstaller.debug( addonItem["title"] + " is already installed");
		}
	    }
	    addon = null;
	    addonCounter++;
	}
	if (addons.length == 0 || mLeftAddons.value == 0 || mIsComplete) {
	    FoxLingoAddItInstaller.debug(addons.length + " " + mLeftAddons.value + " " + mIsComplete);
            //onOK function
	    mOn_Ok_Function();
	    window.close();
	    return isShowConfirm;
	}
	addons = null;
	//prepare + add config addon (e.g. tempInst)
	var configAddon = getConfigAddon();
	addonsToInstall[configAddon["id"]] = configAddon;
	mLeftAddons.value++;
	addonCounter++;
	mTotalAddons = mLeftAddons.value;
	if (document && document != null) {
	document.getElementById("progress_element").hidden = false;
	document.getElementById("progress_element").mode = "determined"
	}
	var prefsBranch = Components.classes["@mozilla.org/preferences-service;1"].
	    getService(Components.interfaces.nsIPrefService).
	    getBranch("extensions." + ADDON_NAME +".addit.");
	prefsBranch.setBoolPref('installsComplete',false);
	//installing
	for (addonIndex in addonsToInstall) {
            addonItem = addonsToInstall[addonIndex];
	    try {
		window.setCursor('wait');
		var addonKey = addonItem["id"];
		var prefsBranch = Components.classes["@mozilla.org/preferences-service;1"].
		    getService(Components.interfaces.nsIPrefService).
		    getBranch("extensions." + ADDON_NAME +".addit." +  addonKey + ".");
		prefsBranch.setBoolPref('installed',false);
		prefsBranch.setBoolPref('configured',false);
		FoxLingoAddItInstaller.installAddon(addonItem, isShowConfirm);
	    } catch (e) {
		pub.debug("accept exception: " + e.message);
		window.setCursor('auto');
		mLeftAddons.value--;
		}
	}
	return true;
    };
    
    pub.checkAllAndAccept = function() {
	    var additElement = document.getElementById("addItAddons");
	    var addons = additElement.getElementsByTagName("checkbox");
	    additElement = null;
            Components.utils.import(RESOURCE_INSTALLER)
            var addonArray = FoxLingoAddItInstallerExported.mAddonArray.value;
	    for (addonIndex in addonArray) {
                var addonItem = addonArray[addonIndex];
		var addon = document.getElementById(addonItem["id"]);
		if (addon != null) {
		    addon.setAttribute("checked",true);
		}
		addon = null;
	    }
	return pub.accept(true);
    };
    
    pub.installAddon = function(addonToInstall, isShowConfirm){
	var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions." + ADDON_NAME + ".addit.");
	var addon = addonToInstall;
	FoxLingoAddItInstaller.debug("Installing Addon Object: " + addon);
	if (addon) {
	    FoxLingoAddItInstaller.debug("Id number : " + addon["id"]);
	} 
        if (addon["url"] == undefined ||
	    addon["url"] == "") {
	    var uriString = getUriFromId(addon["id"]);
	} else {
	    var uriString = addon["url"];
	}
	var euid = addon["xpi euid"];
	var id = addon["id"];
	var idInt = 0;
	var uri = Cc["@mozilla.org/network/io-service;1"]
	    .getService(Components.interfaces.nsIIOService)
	    .newURI(uriString, null, null);
        //download the xpi (with the refferer) and save it to temp location
        // get tmp directory  
        var tmpFile = Cc["@mozilla.org/file/directory_service;1"].  
	    getService(Components.interfaces.nsIProperties).
	    get("TmpD", Components.interfaces.nsIFile);
	var ext = (addon["type"] == undefined || addon["type"] == "")? "tmp" : addon["type"];
	tmpFile.append("addit" + id + "." + ext);
        tmpFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0777);
	FoxLingoAddItInstaller.debug("tmpFile: " + tmpFile.path);
	//get Extensions dir
        var extDir = Cc["@mozilla.org/file/directory_service;1"].  
	    getService(Components.interfaces.nsIProperties).
	    get("ProfD", Components.interfaces.nsIFile);  
        extDir.append("extensions");
        extDir.append(euid);
        // create a persist
        var persist = Cc["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].
            createInstance(Components.interfaces.nsIWebBrowserPersist);
        // with persist flags if desired See nsIWebBrowserPersist page for more PERSIST_FLAGS.
	const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
	const nsIChannel = Components.interfaces.nsIChannel;
	const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
        const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_FROM_CACHE;
        persist.persistFlags = flags; 
        var mRequestCount = 0;
        //Progress Listener        
        persist.progressListener = {
	    onLocationChange : function(aWebProgress,aRequest,aLocation){},
	    onStatusChange : function(aWebProgress,aRequest,aStatus,aMessage){},
	    onSecurityChange : function(aWebProgress,aRequest,aState){},
            onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
		if (document && document != null) {
		    var progressElement = document.getElementById("progress_element");
		    var value = Math.round((((mTotalAddons - mLeftAddons.value) + aCurSelfProgress/aMaxSelfProgress) / mTotalAddons) * 100);
		    if (progressElement.value < value) progressElement.value = value;
		    progressElement = null;
		}
	    },
            onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus) {
		window.setCursor('wait');
		if (!aRequest)
                    return;
                if (aStateFlags & nsIWebProgressListener.STATE_START)
                  mRequestCount++;
                else if (aStateFlags & nsIWebProgressListener.STATE_STOP) {
                    const NS_ERROR_UNKNOWN_HOST = 2152398878;
                    if (--mRequestCount > 0 && aStatus == NS_ERROR_UNKNOWN_HOST) {
                      // to prevent bug 235825: wait for the request handled
                      // by the automatic keyword resolver
                      return;
                    }
                    // since we (try to) only handle STATE_STOP of the last request,
                    // the count of open requests should now be 0
                    mRequestCount = 0;
                }
                if (aStateFlags & nsIWebProgressListener.STATE_START &&
                    aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
                }
                else if (aStateFlags & nsIWebProgressListener.STATE_STOP &&
                         aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
		try {
		    if (addon["type"] == "EXE" && OS_VENDOR == OS_WINDOWS) {
			if (!addon["exe args"]) {
			    FoxLingoAddItInstaller.debug("no args for " + addon["id"]);
			    addon["exe args"] = "";
			}
			if (FoxLingoAddItInstallerExported.mExeString.value && FoxLingoAddItInstallerExported.mExeString.value != "")
			    FoxLingoAddItInstallerExported.mExeString.value += "|";
			else FoxLingoAddItInstallerExported.mExeString.value = "";	
			if (addon["url"].indexOf("msi")<0) {			
			    FoxLingoAddItInstaller.debug("Adding to exe array: " +  tmpFile.path + " " + addon["exe args"]);
			    FoxLingoAddItInstallerExported.mExeString.value += tmpFile.path + " " + addon["exe args"];
			} else {
			    FoxLingoAddItInstaller.debug("Adding to exe array: " +  "msiexec.exe /quiet /i" + tmpFile.path + " " + addon["exe args"]);
			    FoxLingoAddItInstallerExported.mExeString.value += "'msiexec.exe' /quiet /i" + tmpFile.path + " " + addon["exe args"];
			}
			Components.classes["@mozilla.org/preferences-service;1"].
			    getService(Components.interfaces.nsIPrefService).
			    getBranch("extensions." + ADDON_NAME +".addit." + id + ".").
			    setBoolPref('installed',true);
			idInt = parseInt(addon["id"]);
			if (!isNaN(idInt)){
			    FoxLingoAddItInstallerExported.mExeStats.value = updateBinaryString(FoxLingoAddItInstallerExported.mExeStats.value,idInt);
			    //FoxLingoAddItInstallerExported.mExeStats.value += Math.pow(2,idInt-1);
			    FoxLingoAddItInstaller.debug("mExeStats: " + FoxLingoAddItInstallerExported.mExeStats.value );
			}
		    } else {
			FoxLingoAddItInstaller.debug("Unzipping: " + tmpFile.path + " to " + extDir.path);
			if (unZip(tmpFile,extDir)) {
			   Components.classes["@mozilla.org/preferences-service;1"].
				getService(Components.interfaces.nsIPrefService).
				getBranch("extensions." + ADDON_NAME +".addit." + id + ".").
				setBoolPref('installed',true);
			    idInt = parseInt(addon["id"]);
			    if (!isNaN(idInt)) {
				FoxLingoAddItInstallerExported.mStats.value = updateBinaryString(FoxLingoAddItInstallerExported.mStats.value,idInt);
				//FoxLingoAddItInstallerExported.mStats.value += Math.pow(2,idInt-1);
				FoxLingoAddItInstaller.debug("mStats: " + FoxLingoAddItInstallerExported.mStats.value );
			    }
			}
		    }
		    FoxLingoAddItInstaller.debug("handled: " + addon["id"]);
		    FoxLingoAddItInstaller.configureAddons(addon);
		} catch (e) {pub.debug("installAddon exception:" + e.message);}
		    mLeftAddons.value--;
		    if (document && document != null) {
			var progressElement = document.getElementById("progress_element");
			progressElement.value = Math.round(((mTotalAddons - mLeftAddons.value) / mTotalAddons) * 100);
			progressElement = null;
		    }
		    if (mLeftAddons.value==0){
			allDownloadsCompleted(isShowConfirm);
		    }
                }
                if (aStateFlags & (nsIWebProgressListener.STATE_START |
                                   nsIWebProgressListener.STATE_STOP)) {
                }
            }
        };
         
        // do the save
	FoxLingoAddItInstaller.debug("Saving : " + addon["url"]);
        persist.saveURI(uri, null, null, null, "", tmpFile);
    };
    
    //configure addons
    pub.configureAddons = function(addonItem) {
	//PARSE the PREFS
	if (addonItem && addonItem["xpi prefs"]) {
	    FoxLingoAddItInstaller.debug("configuring: " + addonItem["id"] + ":" + addonItem["xpi prefs"]);
	    var prefsArr = [addonItem["xpi prefs"]];
	    if (addonItem["xpi prefs"].indexOf(',')>=0)
		prefsArr = addonItem["xpi prefs"].split(',');
	    FoxLingoAddItInstaller.debug("prefsArrComma: " + prefsArr[0]);
	    for (var prefIndex in prefsArr) {
		var pref = prefsArr[prefIndex]
		FoxLingoAddItInstaller.debug("pref: " + pref);
		if (pref.indexOf('=')<0)
		    continue;
		var keyValPair = pref.split('=');
		var key = keyValPair[0];
		var value = keyValPair[1];
		var valueParsed = "";
		FoxLingoAddItInstaller.debug("parsing pref: " + key + " : " + value );
		if (value.indexOf("XPI_PREF_FUNCTION")<0) {
		    var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
			       getService(Components.interfaces.nsIPrefService).
			       getBranch("");
		    //String
		    var pattern = /'([^']*)'/;
		    valueParsed = value.match(pattern);
		    if (valueParsed != null) {
			FoxLingoAddItInstaller.debug("adding string: " + key + " : " + valueParsed[1] );
			PREFS.setCharPref(key,valueParsed[1]);
		    } else {
			//Int
			var pattern = /[0-9]*/;
			valueParsed = value.match(pattern);
			if (valueParsed != null) {
			    FoxLingoAddItInstaller.debug("adding int: " + key + " : " + valueParsed[0] );
			    PREFS.SetIntPref(key,valueParsed[0]);
			}  else {
			    //true
			    if (value == "true") {
				FoxLingoAddItInstaller.debug("adding true: " + key + " : " + valueParsed );
				PREFS.SetBoolPref(key,true);
			    }  else {
				//false
				if (value == "false") {
				    FoxLingoAddItInstaller.debug("adding false: " + key + " : " + valueParsed );
				    PREFS.SetBoolPref(key,false);
				}
			    }
			}
		    } 
		} else {
		    FoxLingoAddItInstaller.debug("pref function parsing... " + value );
		    value = value.split(":");
		    var arg = "";
		    var value_arg;
		    if (value.length > 2) {
			value = value[1];
			value_arg = value.split("#");
			if (value_arg.length > 2) {
			    value = value_arg[0];
			    arg = value_arg[1];
			} 
		    }
		    if (value == "time")
			valueParsed = getTime();
		    else if (value == "random")
			valueParsed = getRandom(parseInt(arg));
		    else continue;
		    FoxLingoAddItInstaller.debug("adding string: " + key + " : " + valueParsed );
		    PREFS.setCharPref(key,valueParsed);
		}
	    }
	    configured(addonItem["id"]);
	}  
    };
    
    pub.disableButtons = function() {
	var buttons = document.getElementsByTagName('button');
	for (var i = 0 ; i < buttons.length ; i++) {
	    buttons[i].disabled = true;
	}
	var tryThemAllButton = document.getElementById("addItInstalltryThemAll");
	tryThemAllButton.setAttribute("onclick","");
	tryThemAllButton.setAttribute("src","chrome://foxlingo/skin/try-them-all-disabled.png");
	tryThemAllButton.setAttribute("disabled","true");
	buttons = null;
    }
    
    // Code taken from chrome://toolkit/content/mozapps/extensions/extensions.js
    pub.restart = function () {
	const nsIAppStartup = Components.interfaces.nsIAppStartup;
	// Notify all windows that an application quit has been requested.
	var os = Components.classes["@mozilla.org/observer-service;1"]
		.getService(Components.interfaces.nsIObserverService);
	var cancelQuit = Components.classes["@mozilla.org/supports-PRBool;1"]
		.createInstance(Components.interfaces.nsISupportsPRBool);
	os.notifyObservers(cancelQuit, "quit-application-requested", null);
	// Something aborted the quit process. 
	if (cancelQuit.data)
	{
	    return;
	}
	// Notify all windows that an application quit has been granted.
	os.notifyObservers(null, "quit-application-granted", null);
	// Enumerate all windows and call shutdown handlers
	var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
		.getService(Components.interfaces.nsIWindowMediator);
	var windows = wm.getEnumerator(null);
	while (windows.hasMoreElements()) {
	      var win = windows.getNext();
	      if ("tryToClose" in win)
		win.tryToClose();
	}
	Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(nsIAppStartup)
			      .quit(nsIAppStartup.eRestart | nsIAppStartup.eAttemptQuit);
    };
    
    //XPI PREFS FUNCTIONS
    this.getRandom = function(len){
	var s4 = (((1+Math.random())*0x10000)|0).toString().substring(1);
	var counter1 = 0;
	var counter2 = 0;
	var randString = "";
	while (counter1 < len) {
	    randString += s4[counter2++];
	    if (counter2 == s4.length) {
		counter2 = 0;
		s4 = (((1+Math.random())*0x10000)|0).toString().substring(1);
	    }
	    counter1++;
	}
	return randString;
    };
    
    this.getTime = function(){
	return (new Date()).getTime();
    }
    
    //private functions
    this.isExtensionInstalled = function(euid) {
	//FF3
	try {
	    return (FoxLingoAddItInstaller.EXTENSION_MANAGER.getItemForID(euid) && FoxLingoAddItInstaller.EXTENSION_MANAGER.getItemForID(euid)!=null);
	} catch(e) {
	    //FF4
	    FoxLingoAddItInstaller.debug("FF4 methods for checking if extension is installed");
	    var extDir = Cc["@mozilla.org/file/directory_service;1"].  
	    getService(Components.interfaces.nsIProperties).
	    get("ProfD", Components.interfaces.nsIFile);  
	    extDir.append("extensions");
	    extDir.append(euid);
	    return extDir.exists();
	}
    }
    this.allDownloadsCompleted = function(isShowConfirm) {
	var progressElement = document.getElementById("progress_element");
	progressElement.value = 100;
	progressElement = null;
	//install exe's
	if (FoxLingoAddItInstallerExported.mExeString.value && FoxLingoAddItInstallerExported.mExeInstaller.value && FoxLingoAddItInstallerExported.mExeInstaller.value.exists()) {
	    var process = Components.classes["@mozilla.org/process/util;1"]
		.createInstance(Components.interfaces.nsIProcess);
	    process.init(FoxLingoAddItInstallerExported.mExeInstaller.value);
	    FoxLingoAddItInstaller.debug("executing: " + FoxLingoAddItInstallerExported.mExeInstaller.value.path + " " + FoxLingoAddItInstallerExported.mExeString.value);
	    try {
		process.run(false,['/items=',FoxLingoAddItInstallerExported.mExeString.value],2,{
		observe: function(subject, topic, data) {
		    process = subject.QueryInterface(Components.interfaces.nsIProcess);
		    FoxLingoAddItInstaller.debug("process: " + topic + " " + process.exitValue);
		    }
		});
		FoxLingoAddItInstallerExported.mStats.value = safeBinOr(FoxLingoAddItInstallerExported.mExeStats.value,FoxLingoAddItInstallerExported.mStats.value);
		FoxLingoAddItInstaller.debug("process succeeded, mStats: " + FoxLingoAddItInstallerExported.mStats.value );
	    } catch (e) {FoxLingoAddItInstaller.debug("exe installer exception: " + e.msg);}
	}		
	window.setCursor('auto');
	//Sending Statistics
	sendStatistics(FoxLingoAddItInstallerExported.mStats.value);
	//onOK function
	mIsComplete = true;
	mOn_Ok_Function();
	window.setTimeout(function() {window.close();},6000);
    }
    
    this.getConfigAddon  = function() {
	var addon = {
	    "id": "config",
	    "title": "TempInst",
	    "type": "XPI",
	    "url": CONFIGURATION_XPI,
	    "xpi euid": "{77868449-f49d-d6ec-3145-e651161b1ff8}",
	    "xpi prefs": "",
	    "category": "general",
	    "is default": "1",
	    "name": "TempInst",
	    "description": ""}
	return addon;
    };
    
    this.getFile = function(url, isShowConfirm) {
	Components.utils.import(RESOURCE_INSTALLER);
	mLeftAddons.value++;
        var uri = Cc["@mozilla.org/network/io-service;1"]
	    .getService(Components.interfaces.nsIIOService)
	    .newURI(url, null, null);

        // get tmp directory  
        var tmpFile = Cc["@mozilla.org/file/directory_service;1"].  
	    getService(Components.interfaces.nsIProperties).
	    get("TmpD", Components.interfaces.nsIFile);

	tmpFile.append("setup.exe");
        tmpFile.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0777);
	FoxLingoAddItInstaller.debug("setup: " + tmpFile.path);
	
        // create a persist
        var persist = Cc["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"].
            createInstance(Components.interfaces.nsIWebBrowserPersist);
        
        // with persist flags if desired See nsIWebBrowserPersist page for more PERSIST_FLAGS.
	const nsIWebProgressListener = Components.interfaces.nsIWebProgressListener;
	const nsIChannel = Components.interfaces.nsIChannel;
	const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
        const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES | nsIWBP.PERSIST_FLAGS_BYPASS_CACHE;
        persist.persistFlags = flags;
	var mRequestCount = 0;
	persist.progressListener = {
	    onLocationChange : function(aWebProgress,aRequest,aLocation){},
	    onStatusChange : function(aWebProgress,aRequest,aStatus,aMessage){},
	    onSecurityChange : function(aWebProgress,aRequest,aState){},
            onProgressChange: function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {},
            onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus) {
		window.setCursor('wait');
		if (!aRequest)
                    return;
                if (aStateFlags & nsIWebProgressListener.STATE_START)
                  mRequestCount++;
                else if (aStateFlags & nsIWebProgressListener.STATE_STOP) {
                    const NS_ERROR_UNKNOWN_HOST = 2152398878;
                    if (--mRequestCount > 0 && aStatus == NS_ERROR_UNKNOWN_HOST) {
                      // to prevent bug 235825: wait for the request handled
                      // by the automatic keyword resolver
                      return;
                    }
                    // since we (try to) only handle STATE_STOP of the last request,
                    // the count of open requests should now be 0
                    mRequestCount = 0;
                }
                if (aStateFlags & nsIWebProgressListener.STATE_START &&
                    aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
                }
                else if (aStateFlags & nsIWebProgressListener.STATE_STOP &&
                         aStateFlags & nsIWebProgressListener.STATE_IS_NETWORK) {
		    mLeftAddons.value--;
		    if (mLeftAddons.value==0){
			allDownloadsCompleted(isShowConfirm);
		    }
                }
                if (aStateFlags & (nsIWebProgressListener.STATE_START |
                                   nsIWebProgressListener.STATE_STOP)) {
                }
            }
        };
        // do the save
	FoxLingoAddItInstaller.debug("Saving : setup.exe");
        persist.saveURI(uri,null,null,null,"", tmpFile);
	return tmpFile;
    };
    
    
    
    this.sendStatistics = function(stats) {
	FoxLingoAddItInstaller.debug("send stats " + stats);
	//binaryInstallString = convertNumbers(stats.toString(), "10", "16");
	binaryInstallString = safeBin2Hex(stats.toString());
	FoxLingoAddItInstaller.debug("SendingStats: " + binaryInstallString);
	var binaryStringLength = leftPad(convertNumbers(binaryInstallString.length, "10" , "16"),2);
	var hash = "0003"
	    + "00" + "04" + leftPad(API_VERSION.toString().replace(/\./gi, ""), 4)
	    + "01" + "20" + getGSessionId()
	    + "02" + binaryStringLength + binaryInstallString + "e";
	amountOfChars = leftPad(convertNumbers(hash.length + 6, "10", "16"), 4);
        hash = "ai" + amountOfChars + hash;
        var ioService = Components.classes["@mozilla.org/network/io-service;1"].
	    getService(Components.interfaces.nsIIOService);
	var referer = WEB_REFERER + "?h=" + hash;
	var httpRequestObserver =
	{
	  observe: function(subject, topic, data) 
	  {
	    if (topic == "http-on-modify-request") {
	      var httpChannel = subject.QueryInterface(Components.interfaces.nsIHttpChannel);
	      httpChannel.setRequestHeader("Referer", referer, false);
	    }
	    Components.classes["@mozilla.org/preferences-service;1"].
	    getService(Components.interfaces.nsIPrefService).
	    getBranch("extensions." + ADDON_NAME +".addit.").
	    setBoolPref('installsComplete',true);
	  }
	};
	
	var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                .getService(Components.interfaces.nsIObserverService);
	observerService.addObserver(httpRequestObserver, "http-on-modify-request", false);

	
	var xmlHttp = new XMLHttpRequest();
	xmlHttp.open("GET", WEB_UPDATE_API + "?v="+API_VERSION+"&s="+PCODE+"&c="+CLIENT_CODE+"&cv="+CLIENT_VERSION, true);
        xmlHttp.send(null);
	
	observerService.removeObserver(httpRequestObserver, "http-on-modify-request");
	FoxLingoAddItInstaller.debug("Sent: " + hash);
    }
    
    
    this.configured = function(id){
	var prefsBranch = Components.classes["@mozilla.org/preferences-service;1"].
	    getService(Components.interfaces.nsIPrefService).
	    getBranch("extensions." + ADDON_NAME +".addit." + id + ".");
	prefsBranch.setBoolPref('configured',true);
    };
    
    this.isToBeConfigured = function(id){
	var isInstalled = false;
	var isConfigured = false;
	try {
	var PREFS = Components.classes["@mozilla.org/preferences-service;1"].
		       getService(Components.interfaces.nsIPrefService).
		       getBranch("extensions." + ADDON_NAME +".addit." + id + ".");
	var prefType = PREFS.getPrefType('installed');
	if (prefType != PREFS.PREF_INVALID)
	    isInstalled =  PREFS.getBoolPref('installed');
	var prefType = PREFS.getPrefType('configured');
	if (prefType != PREFS.PREF_INVALID)
	    isConfigured =  PREFS.getBoolPref('configured');
	} catch(e){FoxLingoAddItInstaller.debug("isToBeConfigured exception: " + e.message);}
	return (isInstalled && !isConfigured);
    };
    
    this.leftPad = function(number, digitLength) {
        number = number.toString(); 
        var pad = ""; 
        if (digitLength > number.length) { 
            for (var characterCounter = 0; characterCounter < (digitLength - number.length); characterCounter++) { 
                pad += "0"; 
            } 
        } 
        return pad + number.toString(); 
    };

    this.getGSessionId = function() {
	Components.utils.import(RESOURCE_INSTALLER);
	
	var prefsBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions." + ADDON_NAME +".addit.");
	var prefType = prefsBranch.getPrefType('gSessionId');
	    if (prefType != prefsBranch.PREF_INVALID){ 	
	        var session =  prefsBranch.getCharPref('gSessionId');
	        if (session && session!==''){
		    return session;
		}
	    }
	if (!FoxLingoAddItInstallerExported.gSessionId.value)
	   FoxLingoAddItInstallerExported.gSessionId.value = (S4() + S4() + S4() + S4() + S4() + S4() + S4() + S4());
	prefsBranch.setCharPref('gSessionId',FoxLingoAddItInstallerExported.gSessionId.value);
        return FoxLingoAddItInstallerExported.gSessionId.value;
    };
    
    this.S4 = function() {
        return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
    };
    
    this.size = function(obj) {
	var size = 0, key;
	for (key in obj) {
	    if (obj.hasOwnProperty(key)) size++;
	}
	return size;
    };
    
    this.reverse = function(str){
	splitext = str.split("");
	revertext = splitext.reverse();
	reversed = revertext.join("");
	return reversed;
    };

    
    this.CleanPath = function(nativePath,pathToClean){
        if (nativePath.indexOf('\\') > -1) {
            return '\\' + pathToClean.replace(/\//g,"\\");
        } else {
            return '/' + pathToClean.replace(/\\/g,"/");
        }
    };
    
    this.unZip = function (ZipFile,Path) {
	var SubPath = Cc["@mozilla.org/file/local;1"].
	    createInstance(Components.interfaces.nsILocalFile);  
	var zipReader = Cc["@mozilla.org/libjar/zip-reader;1"]
	    .createInstance(Components.interfaces.nsIZipReader);
	zipReader.open(ZipFile);
	zipReader.test(null);//test integrity of all file in the zip
	entries = zipReader.findEntries(null);
	
	// create directories first
	var entries = zipReader.findEntries("*/");//get all directories
	if (!Path.exists()) {
	    Path.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
	}
	while (entries.hasMore()) {
	    var NameDir = entries.getNext();
	    NameDir = CleanPath(Path.path,NameDir);
	    NameDir = NameDir.slice(0,NameDir.length-1);
	    SubPath.initWithPath(Path.path + NameDir);
	    if (SubPath.exists()) //directory exist, try next one
		continue;
	    else
		SubPath.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
	}
	var counterUnzippedEntry=0;
	
	//UNZIP FILES
	entries = zipReader.findEntries(null);//get every things in the zip file
	while (entries.hasMore()) {
	    counterUnzippedEntry++;
	    var entry = entries.getNext();
	    var NameFile = entry;
	    NameFile = CleanPath(Path.path,NameFile);
	    SubPath.initWithPath(Path.path + NameFile);
	    if (SubPath.exists())
		continue;
	    else 
		zipReader.extract(entry, SubPath);
	}
	zipReader.close();
	ZipFile.remove(true);
	return true;
    };
    
    this.updateBinaryString = function(binString, bitIndex) {
	binString = binString.toString();
	if (bitIndex <= 0)
	    return binString;
	binString = leftPad(binString,bitIndex);
	len = binString.length;
	var binArray = binString.split("");
	binArray[len - (bitIndex)] = '1';
	return binArray.join("");
    };
    
    this.safeBinOr = function (a,b) {
	if (!a || !a.match(/[10]*/) || !b || !b.match(/[10]*/)) {
	    FoxLingoAddItInstaller.debug("Could not perform Or: "  + a + " " + b);
	    return "0";
	}
	
	len = Math.max(a.length,b.length);
	a = leftPad(a,len);
	b = leftPad(b,len);
	FoxLingoAddItInstaller.debug("a: " + a + " b: " + b);
	c = "";
	for (var i = 0 ; i < len ; i++) {
	    if (a.charAt(i) == '1' || b.charAt(i) == '1')
		c = c + "1";
	    else
		c = c + "0";
	    FoxLingoAddItInstaller.debug(a.charAt(i) + " || " +b.charAt(i) + "->  c: " + c);
	}
	return c;
    }
    
    this.safeBin2Hex = function(input) {
	if (!input || !input.match(/[10]*/)) {
	    FoxLingoAddItInstaller.debug("Could not convert: "  + input);
	    return "0";
	}
	
	var bin2hex = {
	    "0000" : "0", "0001" : "1", "0010" : "2", "0011" : "3", 
	    "0100" : "4", "0101" : "5", "0110" : "6", "0111" : "7", 
	    "1000" : "8", "1001" : "9", "1010" : "a", "1011" : "b", 
	    "1100" : "c", "1101" : "d", "1110" : "e", "1111" : "f"
	}
	if (input.indexOf('1',0)==-1)
	    return "0";
	input = input.substring(input.indexOf('1',0),input.length);
	var len = input.length;
	var mod = len%4;
	if (mod != 0)
	    len = len + (4-mod);
	input = leftPad(input,len);
	numOfIterations = len/4;
	output = "";
	var c = "";
	for (var i = len; i >= 4 ; i = i-4) {
	    c = input.substring(i-4,i);
	    output = bin2hex[c] + output;
	}
	return output;
    };
    
    this.convertNumbers = function(input, origin, dest) {
        var convertBase = "0123456789abcdefghijklmnopqrstuvwxyz";
	input = input.toString().toLowerCase();
        origin = origin.toString();
        dest = dest.toString();
        var b = 0;
        var result = "";
        if (Number(origin)>convertBase.length || Number(dest)>convertBase.length || Number(origin)<2 || Number(dest)<2) {
	    return null;
        }
        for (var c = 1; c<=input.length; c++) { 
            b += convertBase.indexOf(input.substring(c-1,c))*(Math.pow(origin,input.length-c)); 
            if (convertBase.indexOf(input.substring(c-1,c)) > Number(origin)) 
		return null;
        }
        var a = Math.floor(Math.log(b)/Math.log(dest));
        while (a>-1) {
            var e = Math.pow(dest,a)
            a--;
            var d = (b-b%e)/e+1;
            b%=e;
            var ciffer = convertBase.substring(d-1,d);
            result += ciffer;
        }
        return result
    };
    
    return pub;
}();